package fr.unistra.ibmc.paradise;

/**
 * Warn for a problem related to a biological symbol not recognized by PARADISE  (the id of an atom, of a residue, an organism name...)
 */
public class BiologicalSymbolException extends Exception {

    private String symbol;
    private Object source;

    public BiologicalSymbolException(String message, String symbol, Object source) {
        super(message);
        this.symbol = symbol;
        this.source = source;
    }

    /**
     * The unknown symbol
     *
     * @return
     */
    public String getSymbol() {
        return this.symbol;
    }

    /**
     * The Object having the symbol problem
     *
     * @return
     */
    public Object getSource() {
        return this.source;
    }
}
