package fr.unistra.ibmc.paradise.core;

import fr.unistra.ibmc.paradise.BiologicalSymbolException;

import java.util.List;


public abstract class GenomicDNA extends AbstractMolecule {

    GenomicDNA(ParadiseID paradiseID, MoleculeFactory moleculeFactory, String name, Source source, String sequence) throws BiologicalSymbolException {
        super(paradiseID, moleculeFactory, name, source);
        //three or one-code letter ??
        sequence = sequence.trim().toUpperCase();
        int step = 1;
        //TODO if step = 3 ???
        for (int i = 0; i < sequence.length(); i += step)
            this.addResidue(sequence.substring(i, i + step));
    }

    public void addResidue(String residue) throws BiologicalSymbolException {
        if ("A".equals(residue) || "ADE".equals(residue)) {
            residue = "A";
        } else if ("G".equals(residue) || "GUA".equals(residue)) {
            residue = "G";
        } else if ("C".equals(residue) || "CYT".equals(residue)) {
            residue = "C";
        } else if ("T".equals(residue) || "THY".equals(residue)) {
            residue = "T";
        } else
            residue = "?";
        //throw new BiologicalSymbolException("Unknown Genomic residue "+residue, residue, this);
        this.sequence.append(residue);
    }

    abstract public List<Location> getIntergenicRegions();

}
