package fr.unistra.ibmc.paradise.core;

import fr.unistra.ibmc.paradise.core.features.SequenceFeatureFactory;

import java.io.Serializable;

/**
 * Created by: fjossinet
 * Date: 11 mars 2007
 */
public interface MoleculeFactory extends Serializable {

    public RNA createRNA(ParadiseID paradiseID, String name, Source source, String sequence) throws fr.unistra.ibmc.paradise.BiologicalSymbolException;

    public Protein createProtein(ParadiseID paradiseID, String name, Source source, String sequence) throws fr.unistra.ibmc.paradise.BiologicalSymbolException;

    public LinearGenomicDNA createLinearGenomicDNA(ParadiseID paradiseID, String name, Source source, String sequence) throws fr.unistra.ibmc.paradise.BiologicalSymbolException;

    public CircularGenomicDNA createCircularGenomicDNA(ParadiseID paradiseID, String name, Source source, String sequence) throws fr.unistra.ibmc.paradise.BiologicalSymbolException;

    public String getDescription();

    public SequenceFeatureFactory getSequenceFeatureFactory();

}
