package fr.unistra.ibmc.paradise.core;

import fr.unistra.ibmc.paradise.BiologicalSymbolException;


public final class Protein extends AbstractMolecule {

    Protein(ParadiseID paradiseID, MoleculeFactory moleculeFactory, String name, Source source, String sequence) throws BiologicalSymbolException {
        super(paradiseID, moleculeFactory, name, source);
        //three or one-code letter ??
        sequence = sequence.trim().toUpperCase();
        int step = 1;
        //TODO if step = 3 ???        
        for (int i = 0; i < sequence.length(); i += step)
            this.addResidue(sequence.substring(i, i + step));
    }

    public void addResidue(String residue) throws fr.unistra.ibmc.paradise.BiologicalSymbolException {
        residue = residue.toUpperCase();
        if ("CYS".equals(residue) || "C".equals(residue)) {
            residue = "C";
        } else if ("HIS".equals(residue) || "H".equals(residue)) {
            residue = "H";
        } else if ("ILE".equals(residue) || "I".equals(residue)) {
            residue = "I";
        } else if ("MET".equals(residue) || "M".equals(residue)) {
            residue = "M";
        } else if ("SER".equals(residue) || "S".equals(residue)) {
            residue = "S";
        } else if ("VAL".equals(residue) || "V".equals(residue)) {
            residue = "V";
        } else if ("ALA".equals(residue) || "A".equals(residue)) {
            residue = "A";
        } else if ("GLY".equals(residue) || "G".equals(residue)) {
            residue = "G";
        } else if ("LEU".equals(residue) || "L".equals(residue)) {
            residue = "L";
        } else if ("PRO".equals(residue) || "P".equals(residue)) {
            residue = "P";
        } else if ("THR".equals(residue) || "T".equals(residue)) {
            residue = "T";
        } else if ("PHE".equals(residue) || "F".equals(residue)) {
            residue = "F";
        } else if ("ARG".equals(residue) || "R".equals(residue)) {
            residue = "R";
        } else if ("TYR".equals(residue) || "Y".equals(residue)) {
            residue = "Y";
        } else if ("TRP".equals(residue) || "W".equals(residue)) {
            residue = "W";
        } else if ("ASP".equals(residue) || "D".equals(residue)) {
            residue = "D";
        } else if ("ASN".equals(residue) || "N".equals(residue)) {
            residue = "N";
        } else if ("GLU".equals(residue) || "E".equals(residue)) {
            residue = "E";
        } else if ("GLN".equals(residue) || "Q".equals(residue)) {
            residue = "Q";
        } else if ("LYS".equals(residue) || "K".equals(residue)) {
            residue = "K";
        } else if ("UNK".equals(residue)) {
            residue = "X";
        } else
            residue = "?";
        //throw new BiologicalSymbolException(residue +" is an unknown protein residue", residue, this);
        this.sequence.append(residue);
    }

}
