package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.*;


public abstract class AbstractMainParadiseFeature extends AbstractParadiseFeature implements MainParadiseFeature {

    protected ParadiseID paradiseID;
    protected String name;

    protected AbstractMainParadiseFeature(ParadiseID paradiseID, ParadiseFeatureFactory factory, String name, Source source) {
        super(factory);
        this.paradiseID = paradiseID;
        this.name = name;
        this.source = source;
    }

    public ParadiseID getParadiseID() {
        return this.paradiseID;
    }

    public void setParadiseID(ParadiseID paradiseID) {
        this.paradiseID = paradiseID;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    protected void addSubFeature(int index, ParadiseFeature feature) throws fr.unistra.ibmc.paradise.ArchitectureException {
        if (feature.getAnnotations().size() == 0)
            throw new fr.unistra.ibmc.paradise.ArchitectureException("A feature has to annotate at least one Molecule before to be added as a subfeature", this, feature);
        if (!this.subfeatures.contains(feature)) {
            this.subfeatures.add(index, feature);
            ((AbstractParadiseFeature) feature).parentfeatures.add(this);
            //[fjossinet] A main paradisefeature doesn't add the annotations of the new subfeature if this is another main paradisefeature
            if (!MainParadiseFeature.class.isInstance(feature)) {
                for (Molecule.Annotation a : feature.getAnnotations())
                    a.getMolecule().addFeature(this, a.getLocation());
            }
        }
    }

    public String toString() {
        return this.getName()+" from "+this.getSource().getId();
    }

}
