package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.MoleculeFactory;


public abstract class AbstractParadiseFeatureFactory implements ParadiseFeatureFactory {

    protected String factoryType = "?", description = "?";
    transient protected MoleculeFactory moleculeFactory;

    protected AbstractParadiseFeatureFactory(MoleculeFactory moleculeFactory, String factoryType, String description) {
        this.moleculeFactory = moleculeFactory;
        this.factoryType = factoryType;
        this.description = description;
    }

    public String getFactoryType() {
        return this.factoryType;
    }

    public String getDescription() {
        return this.description;
    }

    public MoleculeFactory getMoleculeFactory() {
        return moleculeFactory;
    }
}
