package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.MoleculeFactory;

/**
 * Created by: fjossinet
 * Date: 11 mars 2007
 */
public abstract class AbstractParadiseFeatureFactoryFactory implements ParadiseFeatureFactoryFactory {

    protected String description;
    protected MoleculeFactory moleculeFactory;

    protected AbstractParadiseFeatureFactoryFactory(MoleculeFactory moleculeFactory,String description) {
        this.description = description;
        this.moleculeFactory = moleculeFactory;
    }

    public IdentityFeatureFactory createIdentityFeatureFactory() {
        return new IdentityFeatureFactory(this.moleculeFactory,this.description);
    }

    public StructuralFeatureFactory createStructuralFeatureFactory() {
        return new StructuralFeatureFactory(this.moleculeFactory,this.description);
    }

    public SequenceFeatureFactory createSequenceFeatureFactory() {
        return new SequenceFeatureFactory(this.moleculeFactory,this.description);
    }

    public String getDescription() {
        return this.description;
    }
}
