package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.BiologicalSymbolException;
import fr.unistra.ibmc.paradise.ArchitectureException;

public class AminoAcid3D extends Residue3D {

    protected AminoAcid3D(StructuralFeatureFactory factory, String name) {
        super(factory, name);
        this.atoms.add(new Atom("N"));
        this.atoms.add(new Atom("H"));
        this.atoms.add(new Atom("HN2"));
        this.atoms.add(new Atom("CA"));
        this.atoms.add(new Atom("HA"));
        this.atoms.add(new Atom("C"));
        this.atoms.add(new Atom("OXT"));
        this.atoms.add(new Atom("O"));
        this.atoms.add(new Atom("HXT"));
    }

    public Atom setAtomCoordinates(String atomName, float x, float y, float z) {
        Atom a;
        a = super.setAtomCoordinates(atomName, x, y, z);
        //TODO each time some Atom coordinates are registered, check if a new TorsionAngle can be calculated
        return a;
    }

    public Residue3D createNewResidue3D(char n) throws BiologicalSymbolException, ArchitectureException {
        throw new ArchitectureException("At now, the creation of a new residue3D is not amplemented for amino-acids");
    }
}
