package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.utils.Residue;


public class AtomAtomInteraction extends StructuralInteraction {

    public static final char INTERACTION_HBOND = 'H';
    public static final char INTERACTION_CH = 'C';
    public static final char INTERACTION_WATER = 'W';
    public static final char INTERACTION_SODIUM = 'N';
    public static final char INTERACTION_MAGNESIUM = 'M';

    protected String atom1, atom2;
    protected Residue residue1, residue2;
    protected char type;

    protected AtomAtomInteraction(StructuralFeatureFactory factory) {
        super(factory);
    }

    public String getAtom1() {
        return atom1;
    }

    public void setAtom1(Residue residue1,String atom1) {
        this.atom1 = atom1;
        this.residue1 = residue1;
    }

    public String getAtom2() {
        return atom2;
    }

    public void setAtom2(Residue residue2,String atom2) {
        this.atom2 = atom2;
        this.residue2 = residue2;
    }

    /**
     * Return the Residue corresponding to the atom 1
     * @return
     */
    public Residue getResidue1() {
        return residue1;
    }

    /**
     * Return the Residue corresponding to the atom 2
     * @return
     */
    public Residue getResidue2() {
        return residue2;
    }

    public void setInteractionType(char type) {
        this.type = type;
    }

    public char getInteractionType() {
        return this.type;
    }
}
