package fr.unistra.ibmc.paradise.core.features;

public class ChemicalModification extends AbstractParadiseFeature {

    private float ratio;
    private String compoundName;

    protected ChemicalModification(SequenceFeatureFactory factory, String compoundName) {
        super(factory);
        this.compoundName = compoundName;
    }

    public SequenceFeatureFactory getFactory() {
        return (SequenceFeatureFactory) super.getFactory();
    }

    /**
     * Register the RNA activity observed for an RNA with this chemical modification
     *
     * @param ratio
     */
    public void setRatio(float ratio) {
        this.ratio = ratio;
    }

    public boolean inhibitFunction() {
        return this.ratio < 1.0;
    }

    /**
     * return the chemical compoundName id used for the modification
     *
     * @return
     */
    public String getName() {
        return this.compoundName;
    }


}
