package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.ParadiseID;
import fr.unistra.ibmc.paradise.core.Source;

public class RNASecondaryStructure extends SecondaryStructure {

    protected RNASecondaryStructure(ParadiseID paradiseID, StructuralFeatureFactory factory, String name, Source source) {
        super(paradiseID, factory, name, source);
    }

    public boolean isSingleStrandPosition(Molecule m,int position) {
        for (Molecule.Annotation a:m.getAnnotations(SingleStrand.class))
            if (a.getLocation().hasPosition(position))
                return true;
        return false;
    }

}
