package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.Location;
import fr.unistra.ibmc.paradise.core.Molecule;


public class ResidueIdentity extends Identity {

    protected ResidueIdentity(IdentityFeatureFactory factory) {
        super(factory);
    }

    protected boolean isBefore(ResidueIdentity ri) {
        for (Molecule.Annotation an : this.getAnnotations()) {
            Location lri = ri.getFullLocation(an.getMolecule());
            if (lri != null) {
                Location lth = an.getLocation();
                return (lth.getStart() < lri.getStart());
            }
        }
        //tludwig here the problem is if this annotates m1 and m2, and ri annotates m3 and m4
        //there is no way to know which one is "before" since they have no molecule in common
        //however imho, this punctual inconsistency should be corrected as soon as
        //- this or ri, annotates one of the other one's molecule
        //- this or ri are both compared to a third RI that have a common molecule with them...
        return false; //by default return false, but true should work as well
    }
}
