package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.ArchitectureException;

import java.util.List;

/**
 * User: fjossinet
 * Date: 18 d�c. 2006
 */
public class SecondaryStructureDisplay extends AbstractParadiseFeature {

    protected SecondaryStructureDisplay(StructuralFeatureFactory factory) throws ArchitectureException {
        super(factory);
    }

    public StructuralFeatureFactory getFactory() {
        return (StructuralFeatureFactory) super.getFactory();
    }

    public void removeResidue2D(Residue2D r) {
        for (Molecule m : r.getMolecules())
            m.removeFeature(r);
        super.removeSubFeature(r);
    }

    public List<Residue2D> getResidues2D() {
        return this.getSubFeatures(Residue2D.class);
    }

}
