package fr.unistra.ibmc.paradise.core.features;

import fr.unistra.ibmc.paradise.core.Location;
import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.MoleculeFactory;

/**
 * Created by: fjossinet
 * Date: 6 mars 2007
 */
public final class SequenceFeatureFactory extends AbstractParadiseFeatureFactory {

    public SequenceFeatureFactory(MoleculeFactory moleculeFactory, String description) {
        super(moleculeFactory, "Primary Sequence", description);
    }

    public ModifiedResidue createModifiedResidue(String symbol, Molecule m,int position) {
        ModifiedResidue r = new ModifiedResidue(this,symbol);
        m.addFeature(r, new Location(position));
        return r;
    }

    public ChemicalModification createChemicalModification(String compoundName, Molecule m, int position) {
        ChemicalModification modification = new ChemicalModification(this, compoundName);
        m.addFeature(modification, new Location(position));
        return modification;
    }


}
