package fr.unistra.ibmc.paradise.core.fetcher;

import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.MoleculeFactory;
import fr.unistra.ibmc.paradise.core.features.AbstractParadiseFeatureFactoryFactory;

import java.util.ArrayList;
import java.util.List;


public abstract class AbstractFetcher extends AbstractParadiseFeatureFactoryFactory implements Fetcher {
    protected String target;
    protected List<Molecule> newMolecules;

    protected AbstractFetcher(String description, String target, MoleculeFactory moleculeFactory) {
        super(moleculeFactory, description);
        this.target = target;
        this.newMolecules = new ArrayList<Molecule>();
    }

    public List<Molecule> getNewMolecules() {
        return new ArrayList<Molecule>(this.newMolecules);
    }
}
