package fr.unistra.ibmc.paradise.core.fetcher;

import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.analysis.Parameters;
import fr.unistra.ibmc.paradise.core.features.ParadiseFeatureFactoryFactory;

import java.util.List;

/**
 * Fetch a piece of information over the network and transform it as a set of PARADISE objects (molecules and annotations)
 */
public interface Fetcher extends ParadiseFeatureFactoryFactory {

    public void fetch(List<Molecule> molecules, Parameters parameters) throws FetchingException;

    public String getDescription();

    /**
     * return the name of the network place targeted by this fetcher
     *
     * @return
     */
    public String getTarget();

    /**
     * Return the molecules created by the analysis
     *
     * @return
     */
    public List<Molecule> getNewMolecules();
}
