package fr.unistra.ibmc.paradise.core.io;

import fr.unistra.ibmc.paradise.core.MoleculeFactory;
import fr.unistra.ibmc.paradise.core.features.AbstractParadiseFeatureFactoryFactory;

import java.io.File;

public abstract class AbstractParadiseFileIO extends AbstractParadiseFeatureFactoryFactory implements ParadiseFileIO {

    protected AbstractParadiseFileIO(String description, MoleculeFactory moleculeFactory) {
        super(moleculeFactory, description);
    }

    protected String getFileSuffix(File f) {
        String[] tokens = f.getName().split("\\.");
        if (tokens.length > 1) {
            return tokens[tokens.length - 1];
        }
        return null;
    }
    
}
