package fr.unistra.ibmc.paradise.core.io;

import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.features.ParadiseFeatureFactoryFactory;
import fr.unistra.ibmc.paradise.core.features.StructuralAlignment;
import fr.unistra.ibmc.paradise.core.features.SecondaryStructure;
import fr.unistra.ibmc.paradise.core.features.TertiaryStructure;
import fr.unistra.ibmc.paradise.tools.component.ProgressMonitor;

import java.io.File;
import java.util.List;

/**
 * Define the concepts of file parser
 * Created by: fjossinet
 * Date: 25 fevr. 2007
 */
public interface ParadiseFileIO extends ParadiseFeatureFactoryFactory {

    /**
     * Return the Molecule objects constructed during the parsing of a file
     *
     * @return
     */
    public List<Molecule> getMolecules();

    public void parseFile(File f, ProgressMonitor monitor) throws FileParsingException, InterruptedException;

    public javax.swing.filechooser.FileFilter getFileFilter();

    public List<StructuralAlignment> getStructuralAlignments();

    public List<SecondaryStructure> getSecondaryStructures();

    public List<TertiaryStructure> getTertiaryStructures();

}
