package fr.unistra.ibmc.paradise.services;

import org.apache.log4j.Priority;

import java.awt.*;

public class LogMessage {
    private long time;
    private Priority priority;
    private String message;
    private String conversationID;
    private String agent;
    private String exception;

    public LogMessage(long time, Priority priority, String message, String conversationID, String agent, String exception) {
        this.time = time;
        this.priority = priority;
        this.message = message;
        this.conversationID = conversationID;
        this.agent = agent;
        this.exception = exception;
    }

    public long getTime() {
        return time;
    }

    public Priority getPriority() {
        return priority;
    }

    public String getMessage() {
        return message;
    }

    public String getConversationID() {
        return conversationID;
    }

    public String getAgent() {
        return agent;
    }

    public String getException() {
        return exception;
    }

    Color getColor() {
        switch (priority.toInt()) {
            case Priority.DEBUG_INT:
                return new Color(0x90, 0xa0, 0xd4);
            case Priority.INFO_INT:
                return new Color(0x74, 0xc4, 0x60);
            case Priority.WARN_INT:
                return new Color(0xfd, 0xff, 0xb8);
            case Priority.ERROR_INT:
                return new Color(0xff, 0x8f, 0x33);
            case Priority.FATAL_INT:
                return new Color(0xff, 0x55, 0x55);
            default:
                return Color.WHITE;
        }
    }
}

