package fr.unistra.ibmc.paradise.services.analysis;

import fr.unistra.ibmc.paradise.core.analysis.Analysis;
import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import org.apache.log4j.Priority;

import java.io.IOException;

/**
 * When a ParadiseAnalysisAgent is contacted the first time for an analysis
 * User: fjossinet
 * Date: 12 mars 2007
 */
public class SubscribeBehaviour extends CyclicBehaviour {
    public void action() {
        ACLMessage message = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.SUBSCRIBE));
        if (message != null) {
            ((ParadiseAnalysisAgent) myAgent).writeLogMessage("Received subscription request from " + message.getSender(), Priority.INFO, message.getConversationId(), myAgent.getName(), null);
            //register the conversation into the ParadisePlatform
            ((ParadiseAnalysisAgent) myAgent).getParadisePlatform().registerConversation(myAgent.getLocalName(), message.getConversationId(), message.getSender());
            ACLMessage answer = message.createReply();
            answer.setPerformative(ACLMessage.CONFIRM);
            //create an Analysis associated with this conversation
            Analysis analysis = ((ParadiseAnalysisAgent) myAgent).addAnalysis(message.getConversationId());
            //the agent send the prerequisites to the requester
            try {
                answer.setContentObject(analysis.getPreRequisites());
            } catch (IOException e) {
                e.printStackTrace();
            }
            myAgent.send(answer);
        } else
            block();
    }
}
