
package fr.unistra.ibmc.paradise.services.analysis.ebi.vrnadistance;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.Holder;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.1.7-b01-
 * Generated source version: 2.1
 * 
 */
@WebService(name = "vrnadistance", targetNamespace = "http://soaplab.ebi.ac.uk/nucleic_rna_folding/vrnadistance")
@XmlSeeAlso({
    ObjectFactory.class
})
public interface Vrnadistance {


    /**
     * starts a job and returns its job identifier that
     * 				can be used by the getStatus and the getResults methods
     * 			
     * 
     * @param run
     * @return
     *     returns java.lang.String
     */
    @WebMethod
    @WebResult(name = "runResponse", targetNamespace = "http://soaplab.org/typedws", partName = "runResponse")
    @SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
    public String run(
        @WebParam(name = "run", targetNamespace = "http://ebi.ac.uk/vrnadistance", partName = "run")
        AppInputs run);

    /**
     * starts a job, waits until it is completed and
     * 				returns the job results
     * 
     * @param compare
     * @param distance
     * @param outfileUrl
     * @param structuresfileUrl
     * @param doalignment
     * @param report
     * @param structuresfileDirectData
     * @param outfile
     * @param detailedStatus
     * @param schapiro
     */
    @WebMethod
    @RequestWrapper(localName = "runAndWaitFor", targetNamespace = "http://ebi.ac.uk/vrnadistance", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnadistance.AppInputs")
    @ResponseWrapper(localName = "runAndWaitForResponse", targetNamespace = "http://ebi.ac.uk/vrnadistance", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnadistance.AppResults")
    public void runAndWaitFor(
        @WebParam(name = "structuresfile_direct_data", targetNamespace = "")
        String structuresfileDirectData,
        @WebParam(name = "structuresfile_url", targetNamespace = "")
        String structuresfileUrl,
        @WebParam(name = "distance", targetNamespace = "")
        List<String> distance,
        @WebParam(name = "compare", targetNamespace = "")
        String compare,
        @WebParam(name = "schapiro", targetNamespace = "")
        Boolean schapiro,
        @WebParam(name = "doalignment", targetNamespace = "")
        Boolean doalignment,
        @WebParam(name = "report", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> report,
        @WebParam(name = "detailed_status", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<Long> detailedStatus,
        @WebParam(name = "outfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfile,
        @WebParam(name = "outfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfileUrl);

    /**
     * returns status of a given job
     * 
     * @param jobId
     * @return
     *     returns java.lang.String
     */
    @WebMethod
    @WebResult(name = "getStatusResponse", targetNamespace = "http://soaplab.org/typedws", partName = "jobStatus")
    @SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
    public String getStatus(
        @WebParam(name = "getStatus", targetNamespace = "http://soaplab.org/typedws", partName = "jobId")
        GetStatusRequest jobId);

    /**
     * returns all results of a given job
     * 			
     * 
     * @param outfileUrl
     * @param report
     * @param jobId
     * @param outfile
     * @param detailedStatus
     */
    @WebMethod
    @RequestWrapper(localName = "getResults", targetNamespace = "http://soaplab.org/typedws", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnadistance.GetResultsRequest")
    @ResponseWrapper(localName = "getResultsResponse", targetNamespace = "http://ebi.ac.uk/vrnadistance", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnadistance.AppResults")
    public void getResults(
        @WebParam(name = "jobId", targetNamespace = "")
        String jobId,
        @WebParam(name = "report", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> report,
        @WebParam(name = "detailed_status", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<Long> detailedStatus,
        @WebParam(name = "outfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfile,
        @WebParam(name = "outfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfileUrl);

}
