
package fr.unistra.ibmc.paradise.services.analysis.ebi.vrnafold;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.Holder;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.1.7-b01-
 * Generated source version: 2.1
 * 
 */
@WebService(name = "vrnafold", targetNamespace = "http://soaplab.ebi.ac.uk/nucleic_2d_structure/vrnafold")
@XmlSeeAlso({
    ObjectFactory.class
})
public interface Vrnafold {


    /**
     * starts a job and returns its job identifier that
     * 				can be used by the getStatus and the getResults methods
     * 			
     * 
     * @param run
     * @return
     *     returns java.lang.String
     */
    @WebMethod
    @WebResult(name = "runResponse", targetNamespace = "http://soaplab.org/typedws", partName = "runResponse")
    @SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
    public String run(
        @WebParam(name = "run", targetNamespace = "http://ebi.ac.uk/vrnafold", partName = "run")
        AppInputs run);

    /**
     * starts a job, waits until it is completed and
     * 				returns the job results
     * 
     * @param ssoutfile
     * @param convert
     * @param constraintfileDirectData
     * @param closegu
     * @param outfileUrl
     * @param report
     * @param ssoutfileUrl
     * @param gu
     * @param sequence
     * @param detailedStatus
     * @param tetraloop
     * @param constraintfileUrl
     * @param energy
     * @param temperature
     * @param scale
     * @param circular
     * @param paramfileDirectData
     * @param paramfileUrl
     * @param outfile
     * @param nsbases
     * @param dangles
     * @param lp
     */
    @WebMethod
    @RequestWrapper(localName = "runAndWaitFor", targetNamespace = "http://ebi.ac.uk/vrnafold", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnafold.AppInputs")
    @ResponseWrapper(localName = "runAndWaitForResponse", targetNamespace = "http://ebi.ac.uk/vrnafold", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnafold.AppResults")
    public void runAndWaitFor(
        @WebParam(name = "sequence", targetNamespace = "")
        SequenceInput sequence,
        @WebParam(name = "constraintfile_direct_data", targetNamespace = "")
        String constraintfileDirectData,
        @WebParam(name = "constraintfile_url", targetNamespace = "")
        String constraintfileUrl,
        @WebParam(name = "paramfile_direct_data", targetNamespace = "")
        String paramfileDirectData,
        @WebParam(name = "paramfile_url", targetNamespace = "")
        String paramfileUrl,
        @WebParam(name = "temperature", targetNamespace = "")
        Float temperature,
        @WebParam(name = "circular", targetNamespace = "")
        Boolean circular,
        @WebParam(name = "gu", targetNamespace = "")
        Boolean gu,
        @WebParam(name = "closegu", targetNamespace = "")
        Boolean closegu,
        @WebParam(name = "lp", targetNamespace = "")
        Boolean lp,
        @WebParam(name = "convert", targetNamespace = "")
        Boolean convert,
        @WebParam(name = "nsbases", targetNamespace = "")
        String nsbases,
        @WebParam(name = "tetraloop", targetNamespace = "")
        Boolean tetraloop,
        @WebParam(name = "energy", targetNamespace = "")
        String energy,
        @WebParam(name = "scale", targetNamespace = "")
        Float scale,
        @WebParam(name = "dangles", targetNamespace = "")
        String dangles,
        @WebParam(name = "report", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> report,
        @WebParam(name = "detailed_status", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<Long> detailedStatus,
        @WebParam(name = "outfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfile,
        @WebParam(name = "outfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfileUrl,
        @WebParam(name = "ssoutfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> ssoutfile,
        @WebParam(name = "ssoutfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> ssoutfileUrl);

    /**
     * returns status of a given job
     * 
     * @param jobId
     * @return
     *     returns java.lang.String
     */
    @WebMethod
    @WebResult(name = "getStatusResponse", targetNamespace = "http://soaplab.org/typedws", partName = "jobStatus")
    @SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
    public String getStatus(
        @WebParam(name = "getStatus", targetNamespace = "http://soaplab.org/typedws", partName = "jobId")
        GetStatusRequest jobId);

    /**
     * returns all results of a given job
     * 			
     * 
     * @param ssoutfile
     * @param outfileUrl
     * @param report
     * @param jobId
     * @param ssoutfileUrl
     * @param outfile
     * @param detailedStatus
     */
    @WebMethod
    @RequestWrapper(localName = "getResults", targetNamespace = "http://soaplab.org/typedws", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnafold.GetResultsRequest")
    @ResponseWrapper(localName = "getResultsResponse", targetNamespace = "http://ebi.ac.uk/vrnafold", className = "fr.unistra.ibmc.paradise.services.analysis.ebi.vrnafold.AppResults")
    public void getResults(
        @WebParam(name = "jobId", targetNamespace = "")
        String jobId,
        @WebParam(name = "report", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> report,
        @WebParam(name = "detailed_status", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<Long> detailedStatus,
        @WebParam(name = "outfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfile,
        @WebParam(name = "outfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> outfileUrl,
        @WebParam(name = "ssoutfile", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> ssoutfile,
        @WebParam(name = "ssoutfile_url", targetNamespace = "", mode = WebParam.Mode.OUT)
        Holder<String> ssoutfileUrl);

}
