package fr.unistra.ibmc.paradise.services.analysis.ibmc.rnart;

import fr.unistra.ibmc.paradise.utils.Printing;

import java.io.*;
import java.util.StringTokenizer;

/**
 * Java version of incnuc.f 13/09/2005 (Thomas Ludwig)<br/>
 * Not translated but rewritten !!!!<br/>
 * FYI : the original incnuc.f is at the end of this file<br/>
 * <br/>
 * Program INCNUC<br/>
 * PROGRAM TO INCREASE THE CYCLE NUMBER IN LSQ.DAT<br/>
 * THE PROGRAM WILL INSERT DAMP(JABN+1)=DAMP(JABN).<br/>
 * 30 CYCLES ARE ALLOWED.<br/>
 * <br/>
 * E.WESTHOF 02/1982<br/>
 * <p>Title: Fortran To Java</p>
 * <p/>
 * <p>Description: Java version of old Fortran Tools (nahelix, fragment, nuclin,
 * nuclsq...)</p>
 * <p/>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p/>
 * <p>Company: IBMC/CNRS - Strasbourg</p>
 *
 */

public class IncNuc {
    /**
     * path
     */
    public String tmpPath;
    public String inPath;
    public String outPath;


    public IncNuc(String tmpPath) throws RnartException {
        this.tmpPath = tmpPath;
        inPath = tmpPath;
        outPath = tmpPath;
        //line formatting of the output differs from fortran formatting (but anyway its meant for java)
        double[] damp = new double[1000];
        double[] damb = new double[1000];
        double[] damq = new double[1000];
        double[] shftk = new double[1000];

        String lsqdat = inPath + "LSQ.DAT";
        try {
            BufferedReader inlsqdat = new BufferedReader(new FileReader(lsqdat));
            String line = inlsqdat.readLine();
            Printing.justRead(line, lsqdat);
            StringTokenizer tok = new StringTokenizer(line);
            String ik = tok.nextToken();
            line = inlsqdat.readLine();
            Printing.justRead(line, lsqdat);
            tok = new StringTokenizer(line);
            int i1 = Tool.parseInt(tok.nextToken());
            int i2 = Tool.parseInt(tok.nextToken());
            int i3 = Tool.parseInt(tok.nextToken());
            int i4 = Tool.parseInt(tok.nextToken());
            int i5 = Tool.parseInt(tok.nextToken());
            int i6 = Tool.parseInt(tok.nextToken());
            int i7 = Tool.parseInt(tok.nextToken());
            int i8 = Tool.parseInt(tok.nextToken());
            int idaliz = Tool.parseInt(tok.nextToken());
            line = inlsqdat.readLine();
            Printing.justRead(line, lsqdat);
            tok = new StringTokenizer(line);
            int na = Tool.parseInt(tok.nextToken());
            i1 = Tool.parseInt(tok.nextToken());
            i2 = Tool.parseInt(tok.nextToken());
            i3 = Tool.parseInt(tok.nextToken());
            i4 = Tool.parseInt(tok.nextToken());
            i5 = Tool.parseInt(tok.nextToken());
            i6 = Tool.parseInt(tok.nextToken());
            i7 = Tool.parseInt(tok.nextToken());
            i8 = Tool.parseInt(tok.nextToken());
            int i9 = Tool.parseInt(tok.nextToken());
            int nocc = Tool.parseInt(tok.nextToken());
            int itemp = Tool.parseInt(tok.nextToken());
            int nsgr = Tool.parseInt(tok.nextToken());
            for (int i = 0; i < 10; i++) {
                line = inlsqdat.readLine();
                Printing.justRead(line, lsqdat);
            }
            line = inlsqdat.readLine();
            Printing.justRead(line, lsqdat);
            tok = new StringTokenizer(line);
            int jabn = Tool.parseInt(tok.nextToken());
            int nb = tok.countTokens();
            for (int i = 0; i < nb; i++) {
                damp[i] = Tool.parseDouble(tok.nextToken());
            }
            if (jabn > 15) {
                line = inlsqdat.readLine();
                Printing.justRead(line, lsqdat);
                tok = new StringTokenizer(line);
                nb = tok.countTokens();
                for (int i = 15; i < 15 + nb; i++) {
                    damp[i] = Tool.parseDouble(tok.nextToken());
                }
            }
            if (itemp != 0) {
                line = inlsqdat.readLine();
                Printing.justRead(line, lsqdat);
                tok = new StringTokenizer(line);
                nb = tok.countTokens();
                for (int i = 0; i < nb; i++) {
                    damb[i] = Tool.parseDouble(tok.nextToken());
                }
                if (jabn > 15) {
                    line = inlsqdat.readLine();
                    Printing.justRead(line, lsqdat);
                    tok = new StringTokenizer(line);
                    nb = tok.countTokens();
                    for (int i = 15; i < 15 + nb; i++) {
                        damb[i] = Tool.parseDouble(tok.nextToken());
                    }
                }
            }
            if (nocc != 0) {
                line = inlsqdat.readLine();
                Printing.justRead(line, lsqdat);
                tok = new StringTokenizer(line);
                nb = tok.countTokens();
                for (int i = 0; i < nb; i++) {
                    damq[i] = Tool.parseDouble(tok.nextToken());
                }
                if (jabn > 15) {
                    line = inlsqdat.readLine();
                    Printing.justRead(line, lsqdat);
                    tok = new StringTokenizer(line);
                    nb = tok.countTokens();
                    for (int i = 15; i < 15 + nb; i++) {
                        damq[i] = Tool.parseDouble(tok.nextToken());
                    }
                }
            }
            line = inlsqdat.readLine();
            Printing.justRead(line, lsqdat);
            tok = new StringTokenizer(line);
            int irtest = Tool.parseInt(tok.nextToken());
            int nsampl = 0, japn = 0, jabn1 = 0;
            if (tok.countTokens() > 0) {
                nsampl = Tool.parseInt(tok.nextToken());
            }
            if (tok.countTokens() > 0) {
                japn = Tool.parseInt(tok.nextToken());
            }
            if (tok.countTokens() > 0) {
                jabn1 = Tool.parseInt(tok.nextToken());
            }
            if (tok.countTokens() > 0) {
                for (int i = 0; i < jabn1; i++) {
                    shftk[i] = Tool.parseDouble(tok.nextToken());
                }
            }
            inlsqdat.close();
            PrintWriter outlsqdattmp = new PrintWriter(new FileWriter(lsqdat + ".tmp"));
            inlsqdat = new BufferedReader(new FileReader(lsqdat));
            while ((line = inlsqdat.readLine()) != null) {
                outlsqdattmp.println(line);
            }
            inlsqdat.close();
            outlsqdattmp.close();

            BufferedReader inlsqdattmp = new BufferedReader(new FileReader(lsqdat + ".tmp"));
            PrintWriter outlsqdat = new PrintWriter(new FileWriter(lsqdat));
            for (int i = 0; i < 13; i++) {
                line = inlsqdattmp.readLine();
                outlsqdat.println(line);
            }
            jabn++;
            if (jabn == 1) {
                if (damp[0] == 0) {
                    damp[0] = 0.35;
                }
                if (damb[0] == 0) {
                    damb[0] = 0.35;
                }
                if (damq[0] == 0) {
                    damq[0] = 0.35;
                }
            } else {
                damp[jabn - 1] = damp[jabn - 2];
                damb[jabn - 1] = damb[jabn - 2];
                damq[jabn - 1] = damq[jabn - 2];
            }
            String tmp = jabn + "";
            for (int i = 0; i < 15; i++) {
                tmp += " " + damp[i];
            }
            outlsqdat.println(tmp);
            if (jabn > 15) {
                tmp = damp[15] + "";
                for (int i = 16; i < jabn; i++) {
                    tmp += " " + damp[i];
                }
                outlsqdat.println(tmp);
            }
            if (itemp != 0) {
                tmp = damb[0] + "";
                for (int i = 1; i < 15; i++) {
                    tmp += " " + damb[i];
                }
                outlsqdat.println(tmp);
                if (jabn > 15) {
                    tmp = damb[15] + "";
                    for (int i = 16; i < jabn; i++) {
                        tmp += " " + damb[i];
                    }
                    outlsqdat.println(tmp);
                }
            }
            if (nocc != 0) {
                tmp = damq[0] + "";
                for (int i = 1; i < 15; i++) {
                    tmp += " " + damq[i];
                }
                outlsqdat.println(tmp);
                if (jabn > 15) {
                    tmp = damq[15] + "";
                    for (int i = 16; i < jabn; i++) {
                        tmp += " " + damq[i];
                    }
                    outlsqdat.println(tmp);
                }
            }
            tmp = irtest + " " + nsampl + " " + japn + " " + jabn1;
            for (int i = 0; i < jabn1; i++) {
                tmp += " " + shftk[i];
            }
            outlsqdat.println(tmp);
            inlsqdattmp.close();
            outlsqdat.close();
        }
        catch (IOException e) {
            throw new RnartException(e);
        }
    }
}
