package fr.unistra.ibmc.paradise.services.community;

import java.io.Serializable;

import jade.core.AID;

/**
 * 
 * This class represent a community contact which is contained by a ParadiseCommunityAgent
 * Maybe adding the class used for agent
 * all the variables are public in order to use it like a structure
 * @author F. Pozzobon
 *
 */

public class Contact implements Serializable{

	private static final long serialVersionUID = -7118389825310411433L;
	
	// The name of the contact
	public String name="";
	
	// his unique ID
	public AID id;
	
	// if he logged on with a password
	public boolean registered;

	/**
	 * Empty constructor
	 */
	public Contact()
	{
	}
	
	/**
	 * Constructor with an id a name and if he is or not registered
	 * @param _id
	 * @param _name
	 * @param registered
	 */
	public Contact(AID _id, String _name, boolean registered)
	{
		this.id = _id;
		this.name = _name;
		this.registered = registered;
	}
	
	
	
	/**
	 * Equality comparison of a contact (compare juste the name and the id)
	 */
	public boolean equals(Object obj) {
		if(obj instanceof Contact){
			Contact contact=(Contact) obj;
			return contact.name.equals(name)&&contact.id.equals(id);
		}
		return false;
	}

	/**
	 * When we show this object it displays the name
	 */
	public String toString(){
		return name;
	}
	
	
}
