package fr.unistra.ibmc.paradise.tools;

import jade.core.behaviours.Behaviour;
import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.analysis.Parameter;
import fr.unistra.ibmc.paradise.core.analysis.Parameters;

import java.util.ArrayList;


public abstract class AnswerBehaviour extends Behaviour {
    protected String conversationId;
    protected boolean done;
    protected ArrayList<Molecule> selectedMolecules;
    protected Parameters selectedParameters;
    protected fr.unistra.ibmc.paradise.tools.component.ProgressMonitor monitor;
    protected String serviceName, serviceType;

    public AnswerBehaviour(ArrayList<Molecule> selectedMolecules, Parameters selectedParameters) {
        this(System.currentTimeMillis() + "" + Math.random(), selectedMolecules, selectedParameters);
    }

    public AnswerBehaviour(String conversationId, ArrayList<Molecule> selectedMolecules, Parameters selectedParameters) {
        this.conversationId = conversationId;
        this.selectedMolecules = selectedMolecules;
        this.selectedParameters = selectedParameters;
    }

    public void setProgressMonitor(fr.unistra.ibmc.paradise.tools.component.ProgressMonitor monitor) {
        this.monitor = monitor;
    }

    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }

    public String getConversationId() {
        return conversationId;
    }

    public ArrayList<Molecule> getSelectedMolecules() {
        return selectedMolecules;
    }

    public Parameters getSelectedParameters() {
        return selectedParameters;
    }

    public boolean done() {
        return this.done;
    }

}
