package fr.unistra.ibmc.paradise.tools;

import fr.unistra.ibmc.paradise.tools.component.ProgressMonitor;
import com.wolfram.jlink.ui.ConsoleWindow;


public class MathematicaTool extends AbstractParadiseTool {

    private MathematicaToolProgressMonitor progressMonitor;

    public MathematicaTool(ParadiseWorkingSession workingSession) {
        super("Mathematica", workingSession);
        this.progressMonitor = new MathematicaToolProgressMonitor();
    }

    public void launch() {
        System.out.println("Mathematica is now linked to PARADISE!!");
        System.out.println("This window will be used to display messages and errors...");
    }

    public fr.unistra.ibmc.paradise.tools.component.ProgressMonitor getProgressMonitor() {
        return this.progressMonitor;
    }

    private class MathematicaToolProgressMonitor implements ProgressMonitor {

        private ConsoleWindow consoleWindow;

        private MathematicaToolProgressMonitor() {
            this.consoleWindow = ConsoleWindow.getInstance();
            this.consoleWindow.setLocation(100, 100);
            this.consoleWindow.setSize(450, 400);
            this.consoleWindow.show();
            this.consoleWindow.setCapture(ConsoleWindow.STDOUT | ConsoleWindow.STDERR);            
        }

        public void printException(Exception e) {
            System.out.println(e.getMessage());
            for (StackTraceElement el:e.getStackTrace())
                System.out.println(el.toString());
        }

        public void printMessage(String message) {
            System.out.println(message);
        }

        public void startAnimation() {
        }

        public void stopAnimation() {
        }
    }
}
