package fr.unistra.ibmc.paradise.tools;

import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.lang.acl.ACLMessage;
import jade.wrapper.StaleProxyException;


public interface ParadiseToolAgent {

    public void send(ACLMessage msg);

    /**
     * Return the description for all agents registered in a category given as argument
     * @param category
     * @return
     */
    public DFAgentDescription[] findAgents(String category);

    /**
     * Return the description of an agent whose name and category are given as argument
     * @param category
     * @param name
     * @return null if no such agent has been found
     */
    public DFAgentDescription findAgent(String category, String name);


    /**
     * return the ParadiseTool linked to this agent
     * @return
     */
    public ParadiseTool getParadiseTool();

    public void connectToPlatform() throws StaleProxyException;
}
