/*
 * Created by JFormDesigner on Mon Jul 09 11:38:21 CEST 2007
 */

package fr.unistra.ibmc.paradise.tools.component;

import org.jdesktop.swingx.JXFrame;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Fabrice Jossinet
 */
public class ParadiseProgressBar extends JXFrame implements ActionListener {

    private int i = 0;
    private Timer timer;

    public ParadiseProgressBar(final ParadiseTask task) {
        initComponents();
        this.cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                task.cancel(true);
                stop();
            }
        });
        class MyTimer extends Timer {
            public MyTimer(ActionListener actionListener) {
                super(100, actionListener);
            }

            public void stop() {
                super.stop();
                paradise_logo.setIcon(new ImageIcon(getClass().getResource("/fr/unistra/ibmc/paradise/images/paradise-icon0.png")));
            }
        }
        this.timer = new MyTimer(this);
        this.setVisible(false);
    }

    public void actionPerformed(ActionEvent e) {
        paradise_logo.setIcon(new ImageIcon(getClass().getResource("/fr/unistra/ibmc/paradise/images/paradise-icon" + (i++) + ".png")));
        if (this.i == 15)
            this.i = 0;
    }

    public void start() {
        this.setVisible(true);
        this.timer.start();
    }

    public void stop() {
        this.timer.stop();
        this.dispose();
    }

    public void setMessage(String message) {
        this.messageField.setText(message);
    }

    private void initComponents() {
        this.setUndecorated(true);
        this.panel1 = new JPanel();
        this.panel7 = new JPanel();
        this.messageField = new JTextPane();
        this.panel5 = new JPanel();
        this.paradise_logo = new JLabel();
        this.panel6 = new JPanel();
        this.cancel = new JButton();

        //======== this ========
        setBackground(Color.white);
        setForeground(Color.white);
        setFocusTraversalPolicyProvider(true);
        setResizable(false);
        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());

        //======== panel1 ========
        {
            this.panel1.setBackground(Color.white);
            this.panel1.setLayout(new BorderLayout());

            //======== panel7 ========
            {
                this.panel7.setBackground(Color.white);
                this.panel7.setPreferredSize(new Dimension(200, 200));
                this.panel7.setMinimumSize(new Dimension(200, 200));
                this.panel7.setMaximumSize(new Dimension(200, 200));
                this.panel7.setLayout(new CardLayout(10, 50));

                //---- messageField ----
                messageField.setMinimumSize(new Dimension(300, 200));
                this.messageField.setBackground(Color.white);
                this.messageField.setPreferredSize(new Dimension(200, 200));
                this.messageField.setMaximumSize(new Dimension(200, 200));
                this.messageField.setMinimumSize(new Dimension(200, 200));
                this.messageField.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
                this.messageField.setEditable(false);
                this.panel7.add(this.messageField, "card1");
            }
            this.panel1.add(this.panel7, BorderLayout.CENTER);

            //======== panel5 ========
            {
                this.panel5.setBackground(Color.white);
                this.panel5.setMinimumSize(new Dimension(200, 200));
                this.panel5.setLayout(new FlowLayout());

                //---- paradise_logo ----
                this.paradise_logo.setIcon(new ImageIcon(getClass().getResource("/fr/unistra/ibmc/paradise/images/paradise-icon0.png")));
                this.paradise_logo.setHorizontalAlignment(SwingConstants.CENTER);
                this.paradise_logo.setPreferredSize(new Dimension(100, 200));
                this.paradise_logo.setMaximumSize(new Dimension(100, 200));
                this.paradise_logo.setMinimumSize(new Dimension(100, 200));
                this.panel5.add(this.paradise_logo);
            }
            this.panel1.add(this.panel5, BorderLayout.WEST);

            //======== panel6 ========
            {
                this.panel6.setBackground(Color.white);
                this.panel6.setLayout(new FlowLayout());

                //---- cancel ----
                this.cancel.setText("Cancel");
                this.cancel.setBackground(Color.white);
                this.panel6.add(this.cancel);
            }
            this.panel1.add(this.panel6, BorderLayout.SOUTH);
        }
        contentPane.add(this.panel1, BorderLayout.CENTER);
        pack();
        setLocationRelativeTo(getOwner());
    }

    private JPanel panel1;
    private JPanel panel7;
    private JTextPane messageField;
    private JPanel panel5;
    private JLabel paradise_logo;
    private JPanel panel6;
    private JButton cancel;
}
