package fr.unistra.ibmc.paradise.tools.component;

import fr.unistra.ibmc.paradise.tools.ParadiseToolAgent;
import fr.unistra.ibmc.paradise.utils.GeneralUtils;
import jade.core.AID;
import jade.lang.acl.ACLMessage;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class ProgressBar extends JFrame {
    private JProgressBar progress;
    private JLabel label1;
    private JButton cancel;
    private JPanel topPanel;
    //the receiver of the original message
    private AID receiver;
    //the ParadiseTool that sent the message
    private ParadiseToolAgent toolAgent;
    private String conversationId;

    public ProgressBar(String conversationId, String text, AID receiver, ParadiseToolAgent toolAgent) {
        this.conversationId = conversationId;
        this.receiver = receiver;
        this.toolAgent = toolAgent;
        this.setTitle("Please wait...");
        this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        this.setResizable(false);
        topPanel = new JPanel();
        topPanel.setPreferredSize(new Dimension(310, 100));
        this.add(topPanel);

        label1 = new JLabel(text);
        label1.setPreferredSize(new Dimension(280, 24));
        topPanel.add(label1);

        progress = new JProgressBar();
        progress.setPreferredSize(new Dimension(300, 20));
        progress.setIndeterminate(true);
        topPanel.add(progress);

        cancel = new JButton("Cancel");
        cancel.addActionListener(new CancelListener());
        topPanel.add(cancel);

        this.pack();
        GeneralUtils.centerOnScreen(this);
        this.setVisible(true);
        this.toFront();
    }

    public void setReceiver(AID receiver) {
        this.receiver = receiver;
    }

    public void setMessage(String message) {
        this.label1.setText(message);
    }

    private class CancelListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            ACLMessage cancel = new ACLMessage(ACLMessage.CANCEL);
            cancel.setConversationId(ProgressBar.this.conversationId);
            if (receiver != null)
                cancel.addReceiver(receiver);
            toolAgent.send(cancel);
            ProgressBar.this.dispose();
        }
    }
}
