package fr.unistra.ibmc.paradise.utils;

import java.io.*;

public class FileHandler {
    public static final int READING = 0;
    public static final int WRITING = 1;
    public static final int R_APPEND = 2;
    public static final int W_APPEND = 3;

    public String name = "";
    public int mode = 0;
    private BufferedReader in;
    private PrintWriter out;

    public static void appendTo(String filenameA, String filenameB) {
        try {
            BufferedReader in = new BufferedReader(new FileReader(filenameA));
            PrintWriter out = new PrintWriter(new FileWriter(filenameB, true));
            String line;
            while ((line = in.readLine()) != null) {
                out.println(line);
            }
            out.close();
            in.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static byte[] readFile(String filename) {
        byte[] ret = null;
        try {
            FileInputStream in = new FileInputStream(filename);
            ByteArrayOutputStream buffer = new ByteArrayOutputStream();
            byte[] temp = new byte[1024];
            int read;

            while ((read = in.read(temp)) > 0) {
                buffer.write(temp, 0, read);
            }
            in.close();
            ret = buffer.toByteArray();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        return ret;
    }

    public static String readFileToString(String filename) {
        return new String(readFile(filename));
    }

    public PrintWriter getOut() {
        return out;
    }

    public BufferedReader getIn() {
        return in;
    }

    public FileHandler(String s, int mod) {
        try {
            if (mod == READING) {
                name = s;
                mode = mod;
                in = new BufferedReader(new FileReader(s));
            }
            /*   if (mod == R_APPEND)
            {
                name = s;
                mode = mod;
                in = new BufferedReader(new FileReader(s,true));
            }*/
            if (mod == WRITING) {
                name = s;
                mode = mod;
                out = new PrintWriter(new FileWriter(s));
            }
            if (mod == W_APPEND) {
                name = s;
                mode = mod;
                out = new PrintWriter(new FileWriter(s, true));
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String readLine() {
        try {
            String s = in.readLine();
            Throwable toto = new Throwable();
            StackTraceElement t = toto.getStackTrace()[1];
            String cn = t.getClassName();
            if (cn.lastIndexOf(".") > -1) {
                cn = cn.substring(cn.lastIndexOf(".") + 1);
            }
            if (Printing.getReadMode() == OutputMode.onOut) {
                System.out.println("Read : " + cn + "." + t.getMethodName() + "() line :" + t.getLineNumber() + " | in " + name + " | " + s);
            }
            if (Printing.getReadMode() == OutputMode.onErr) {
                System.err.println("Read : " + cn + "." + t.getMethodName() + "() line :" + t.getLineNumber() + " | in " + name + " | " + s);

            }
            return s;
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        return "";
    }

    public void println() {

        out.println();

    }

    public void println(String s) {

        out.println(s);
        Throwable toto = new Throwable();
        StackTraceElement t = toto.getStackTrace()[1];
        String cn = t.getClassName();
        if (cn.lastIndexOf(".") > -1) {
            cn = cn.substring(cn.lastIndexOf(".") + 1);
        }
        if (Printing.getWriteMode() == OutputMode.onOut) {
            System.out.println("Write : " + cn + "." + t.getMethodName() + "() line :" + t.getLineNumber() + " | in " + name + " | " + s);
        }
        if (Printing.getWriteMode() == OutputMode.onErr) {
            System.err.println("Write : " + cn + "." + t.getMethodName() + "() line :" + t.getLineNumber() + " | in " + name + " | " + s);
        }

    }

    public void close() {
        try {
            if (mode == READING) {
                in.close();
            }
            if (mode == WRITING) {
                out.close();
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void rewind() {
        try {
            if (mode == READING) {
                in.close();
                in = new BufferedReader(new FileReader(name));
            }
            if (mode == WRITING) {
                out.close();
                out = new PrintWriter(new FileWriter(name));
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void switchToReadMode() {
        try {
            if (mode == READING) {
                in.close();
            }
            if (mode == WRITING) {
                out.close();
            }
            mode = READING;
            in = new BufferedReader(new FileReader(name));
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void switchToWriteMode() {
        try {
            if (mode == READING) {
                in.close();
            }
            if (mode == WRITING) {
                out.close();
            }
            mode = WRITING;
            out = new PrintWriter(new FileWriter(name));
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }
}
