package fr.unistra.ibmc.paradise.utils;

import java.util.ArrayList;

public class HD2PDB {
    public HD2PDB() {
    }

    public static void main(String[] args) throws ParsingException {
        Printing.setReadMode(OutputMode.off);
        Printing.setWriteMode(OutputMode.off);
        convert(args[0], args[1], new ArrayList<Integer>());
    }

    public static void convert(String HDFile, String PDBFile, ArrayList<Integer> cut) throws ParsingException {
        /*  System.out.print("cut list ");
        for(int i = 0 ; i < cut.size(); i++)
        {
            int c = ((Integer)cut.get(i)).intValue();
            System.out.print(c+" ");
        }

        System.out.println();*/

        FileHandler hd = new FileHandler(HDFile, FileHandler.READING);
        FileHandler pdb = new FileHandler(PDBFile, FileHandler.WRITING);
        int atn = 1;

        int cur = -1;

        char ch = 'A';
        char oldresName;


        String line;
        HD atom = null;
        while ((line = hd.readLine()) != null) {
            atom = new HD(line);

            if (atom.residueNumber == cur + 1) {
                oldresName = atom.residueName;
                if (myContains(cut, cur)) {
                    pdb.println(PDB.getTerString(atn++, oldresName + "", ch, cur));
                    ch++;
                }

            }
            cur = atom.residueNumber;
            pdb.println(PDB.getAtomString(atn++, atom.atomName, atom.residueName + "", ch, atom.residueNumber, atom.x, atom.y, atom.z));
        }
        if (atom != null) {
            pdb.println(PDB.getTerString(atn++, atom.residueName + "", ch, atom.residueNumber));
        }
        hd.close();
        pdb.close();
    }

    public static void convert(String HDFile, String PDBFile) throws ParsingException {
        /*  System.out.print("cut list ");
        for(int i = 0 ; i < cut.size(); i++)
        {
            int c = ((Integer)cut.get(i)).intValue();
            System.out.print(c+" ");
        }

        System.out.println();*/

        FileHandler hd = new FileHandler(HDFile, FileHandler.READING);
        FileHandler pdb = new FileHandler(PDBFile, FileHandler.WRITING);
        int atn = 1;

        int cur = -1;

        char ch = 'A';
        char oldresName;


        String line;
        HD atom = null;
        while ((line = hd.readLine()) != null) {
            atom = new HD(line);

            if (atom.residueNumber == cur + 1) {
                oldresName = atom.residueName;
            }
            cur = atom.residueNumber;
            pdb.println(PDB.getAtomString(atn++, atom.atomName, atom.residueName + "", ch, atom.residueNumber, atom.x, atom.y, atom.z));
        }
        if (atom != null) {
            pdb.println(PDB.getTerString(atn++, atom.residueName + "", ch, atom.residueNumber));
        }
        hd.close();
        pdb.close();
    }

    private static boolean myContains(ArrayList<Integer> cut, int cur) {
        for (Integer v : cut) {
            if (v == cur) {
                return true;
            }
        }
        return false;
    }
}
