import fr.unistra.ibmc.s2s.S2S
import fr.unistra.ibmc.s2s.rnalign.features.BiologicalSequence
import javax.swing.Timer
import javax.swing.JOptionPane
import java.awt.event.ActionListener

def getBlastResultTimer = null;

String getTitle() {
  "Blast Search";
}

String getDescription() {
  "Select a sequence or subsequence in your alignment and blast it"
}

void run(S2S s2s) {
  for (e in s2s.getAlignmentCanvas().getSelectedPositions().entrySet()) {
    sequence=""
    for (pos in e.getValue())
      sequence += ((BiologicalSequence)e.getKey()).getMolecule().getResidueAt(pos)

    s2s.getProgressMonitor().startAnimation()
    s2s.getProgressMonitor().printMessage("Blast search...")

    url="http://www.ncbi.nlm.nih.gov/blast/Blast.cgi?CMD=Put&DATABASE=nr&PROGRAM=blastn&QUERY="+sequence
    matcher = new URL(url).text =~ /name="RID" value="(.*)" type="hidden"/
    url="http://www.ncbi.nlm.nih.gov/blast/Blast.cgi?CMD=Get&FORMAT_TYPE=XML&RID="+matcher[0][1]

    getBlastResultTimer =new Timer(10000, [
            actionPerformed: {
              result = new URL(url).text
              if (result =~ /BlastOutput/) {
                getBlastResultTimer.stop()
                result = result.replaceFirst("<!DOCTYPE BlastOutput PUBLIC \"-//NCBI//NCBI BlastOutput/EN\" \"NCBI_BlastOutput.dtd\">","")
                println result+"\n"
                blastOutput = new XmlParser().parseText(result)
                hits = blastOutput.BlastOutput_iterations[0].Iteration[0].Iteration_hits[0].children()
                if (hits.size == 0)
                  JOptionPane.showMessageDialog(null, "No significant similarity found");
                else {
                  print "${hits[0]} hits"
                }
                s2s.getProgressMonitor().stopAnimation()
              }
              else
                s2s.getProgressMonitor().printMessage("Waiting for blast results...")
            }
    ] as ActionListener);

    getBlastResultTimer.setInitialDelay(0) 

    getBlastResultTimer.start();

  }
}