import fr.unistra.ibmc.s2s.S2S;
import fr.unistra.ibmc.paradise.tools.ParadiseWorkingSession;
import java.io.*;
import fr.unistra.ibmc.paradise.core.features.Helix;

String getTitle() {
  "Julien Dutheil Work";
}

String getDescription() {
  "a plugin to export structural alignment in a fasta file and interactions in a csv file"
}

void run(S2S s2s) {
  print("Start...\n");
  print("Synchronize data\n");
  s2s.synchronize();
  
  alignment = s2s.getAlignmentCanvas().getMainAlignment();
  interactionsFile = new File("/Users/fjossinet/tmp/interactions.csv");
  referenceMolecule = alignment.getBiologicalReferenceSequence();
  structure2D3D = alignment.getStructure2D3D();
  helixCount = 0;
  for (s in structure2D3D.getSymbols()) {
    if (!s.isGap()) {
	  for (interaction in s.getReferenceBaseBaseInteractions()) {
		l = interaction.getFullLocation(referenceMolecule.getMolecule());
		pos1InSequence = l.getStart();
		pos2InSequence = l.getEnd();
		//to avoid to export it twice
		if (s.getResidue().getAbsolutePosition() < pos2InSequence) {
			pos1InAlignment = structure2D3D.getIndex(s)+1;
			pos2InAlignment = structure2D3D.getIndex(s.getPairedSymbol(interaction))+1;
			helices = interaction.getParentFeatures(Helix.class);
			if (helices.size() != 0) {
				helixName = ((Helix)helices.get(0)).getName();
				if (helixName == null) {
					((Helix)helices.get(0)).setName("H"+(helixCount++));
					helixName = ((Helix)helices.get(0)).getName();
				}
				helixLength = ((Helix)helices.get(0)).getLength();
				interactionsFile << "["+pos1InAlignment+";"+pos2InAlignment+"],["+referenceMolecule.getMolecule().getResidueAt(pos1InSequence)+pos1InSequence+";"+referenceMolecule.getMolecule().getResidueAt(pos2InSequence)+pos2InSequence+"],"+interaction.getFamily()+"\n";
			}
			else
				interactionsFile << "["+pos1InAlignment+";"+pos2InAlignment+"],["+referenceMolecule.getMolecule().getResidueAt(pos1InSequence)+pos1InSequence+";"+referenceMolecule.getMolecule().getResidueAt(pos2InSequence)+pos2InSequence+"],"+interaction.getFamily()+"\n";
		}
      }
    }
  }
  print("Interactions file created\n");

  alignmentFile = new File("/Users/fjossinet/tmp/alignment.fasta");
  for (seq in alignment.getBiologicalSequences()	) {
	alignmentFile << ">"+seq.getMolecule().getName()+"\n";
    alignedSequence = new StringBuffer();
    for (symbol in seq.getSymbols()) {
    	if (symbol.isGap())
			alignedSequence.append('-');
        else
			alignedSequence.append(symbol.getSymbol());
	}
	s = alignedSequence.toString();
	for(c = 0 ; c < s.length() ; c+=80 ) {
		d = Math.min(s.length(),c+80 );
		alignmentFile << s.substring(c,d)+"\n";
	}
  }
  print("Alignment file created\n");
  
}