package fr.unistra.ibmc.s2s;

import fr.unistra.ibmc.paradise.core.analysis.Analysis;
import fr.unistra.ibmc.paradise.tools.ParadiseWorkingSession;
import fr.unistra.ibmc.paradise.tools.AbstractParadiseToolAgent;
import fr.unistra.ibmc.paradise.tools.AnswerBehaviour;
import fr.unistra.ibmc.paradise.Paradise;
import jade.gui.GuiEvent;
import jade.wrapper.StaleProxyException;

import java.util.Iterator;


public class S2SAgent extends AbstractParadiseToolAgent {

    public S2SAgent(ParadiseWorkingSession workingSession) throws StaleProxyException {
        super(new S2S(workingSession));
    }

    public void onGuiEvent(GuiEvent event) {
        Iterator iterator = event.getAllParameter();
        AnswerBehaviour answerBehaviour = null;
        String targetedAgentName = null;
        if (iterator.hasNext())
            answerBehaviour = (AnswerBehaviour) iterator.next();
        if (iterator.hasNext())
            targetedAgentName =(String)iterator.next();
        ListAgentsBehaviour behaviour = null;
        switch (event.getType()) {
            case Paradise.STRUCTURAL_ALIGNMENT:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName, Analysis.STRUCTURAL_ALIGNMENT, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.STRUCTURAL_ALIGNMENT, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
            case Paradise.SECONDARY_STRUCTURE_PREDICTION:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName, Analysis.SECONDARY_STRUCTURE_PREDICTION, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.SECONDARY_STRUCTURE_PREDICTION, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
            case Paradise.SECONDARY_STRUCTURE_DRAWING:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName,Analysis.SECONDARY_STRUCTURE_DRAWING, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.SECONDARY_STRUCTURE_DRAWING, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
            case Paradise.TERTIARY_STRUCTURE_ANNOTATION:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName,Analysis.TERTIARY_STRUCTURE_ANNOTATION, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.TERTIARY_STRUCTURE_ANNOTATION, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
            case Paradise.HELICES_REORGANIZATION:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName,Analysis.SECONDARY_STRUCTURE_DRAWING, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.SECONDARY_STRUCTURE_DRAWING, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
            case Paradise.NC_RNAS_CANDIDATES_SEARCHING:
                if (targetedAgentName != null)
                    behaviour = new ListAgentsBehaviour(targetedAgentName,Analysis.NC_RNAS_CANDIDATES_SEARCHING, answerBehaviour, paradiseTool.getProgressMonitor());
                else
                    behaviour = new ListAgentsBehaviour(Analysis.NC_RNAS_CANDIDATES_SEARCHING, answerBehaviour, paradiseTool.getProgressMonitor());
                break;
        }
        if (behaviour != null)
            this.addBehaviour(behaviour);
    }

}
