package fr.unistra.ibmc.s2s.behaviours;

import fr.unistra.ibmc.paradise.tools.AnswerBehaviour;
import fr.unistra.ibmc.paradise.tools.ParadiseToolAgent;
import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.utils.Residue;
import fr.unistra.ibmc.paradise.core.features.SecondaryStructureDisplay;
import fr.unistra.ibmc.paradise.core.features.Residue2D;
import fr.unistra.ibmc.paradise.core.analysis.Parameter;
import fr.unistra.ibmc.paradise.core.analysis.Parameters;
import fr.unistra.ibmc.s2s.S2S;

import java.util.ArrayList;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.lang.acl.UnreadableException;

public class HelixReorganizationRequestAnswerBehaviour extends AnswerBehaviour {

    public HelixReorganizationRequestAnswerBehaviour(ArrayList<Molecule> selectedMolecules, Parameters selectedParameters) {
        super(selectedMolecules, selectedParameters);
    }

    public void action() {
        ACLMessage message = myAgent.receive(MessageTemplate.MatchConversationId("" + this.conversationId));
        if (message != null && message.getPerformative() == ACLMessage.PROPOSE) {
            try {
                SecondaryStructureDisplay newDisplay = ((ArrayList<Molecule>) message.getContentObject()).get(0).getSelectedFeatures(SecondaryStructureDisplay.class).get(0);
                for (Residue2D residue2D:newDisplay.getResidues2D()) {
                    Residue _r = residue2D.getResidues().iterator().next();
                    fr.unistra.ibmc.s2s.ssviewer.features.Residue2D _residue2D = ((S2S)((ParadiseToolAgent)myAgent).getParadiseTool()).getMediator().getCurrentModel2D().getRepository().getResidue(_r.getMoleculeId(),_r.getAbsolutePosition());
                    _residue2D.setRealCoordinates(residue2D.getX(), residue2D.getY());
                }
                ((S2S)((ParadiseToolAgent)myAgent).getParadiseTool()).getMediator().getSecondaryCanvas().getGraphicContext().initialize();
                ((S2S)((ParadiseToolAgent)myAgent).getParadiseTool()).getMediator().getSecondaryCanvas().repaint();
                monitor.printMessage("End of Analysis");
            }
            catch (Exception e) {
                monitor.printException(e);
            }
            monitor.stopAnimation();
            this.done = true;
        } else if (message != null && message.getPerformative() == ACLMessage.INFORM) {
            monitor.printMessage(message.getContent());
        } else if (message != null && message.getPerformative() == ACLMessage.FAILURE) {
            try {
                   monitor.printException((Exception) message.getContentObject());
                } catch (UnreadableException e) {
                    e.printStackTrace();
                }
            monitor.stopAnimation();
            this.done = true;
        }
    }
}

