package fr.unistra.ibmc.s2s.behaviours;

import fr.unistra.ibmc.paradise.tools.AnswerBehaviour;
import fr.unistra.ibmc.paradise.tools.ParadiseToolAgent;
import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.features.SecondaryStructureDisplay;
import fr.unistra.ibmc.paradise.core.features.SecondaryStructure;
import fr.unistra.ibmc.paradise.core.analysis.Parameter;
import fr.unistra.ibmc.paradise.core.analysis.Parameters;
import fr.unistra.ibmc.s2s.S2S;

import java.util.ArrayList;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.lang.acl.UnreadableException;

public class SecondaryStructureDrawingRequestAnswerBehaviour extends AnswerBehaviour {

    public SecondaryStructureDrawingRequestAnswerBehaviour(ArrayList<Molecule> selectedMolecules, Parameters selectedParameters) {
        super(selectedMolecules, selectedParameters);
    }

    public void action() {
        ACLMessage message = myAgent.receive(MessageTemplate.MatchConversationId("" + this.conversationId));
        if (message != null && message.getPerformative() == ACLMessage.PROPOSE) {
            try {
                SecondaryStructureDisplay display = ((ArrayList<Molecule>) message.getContentObject()).get(0).getSelectedFeatures(SecondaryStructureDisplay.class).get(0);
                SecondaryStructure ss = this.selectedMolecules.get(0).getSelectedFeatures(SecondaryStructure.class).get(0);
                ss.getFactory().copySecondaryStructureDisplay(selectedMolecules, display, ss);
                ((S2S) ((ParadiseToolAgent)myAgent).getParadiseTool()).loadRNASecondaryStructure(ss);
                monitor.printMessage("End of Analysis");
            }
            catch (Exception e) {
                monitor.printException(e);
            }
            monitor.stopAnimation();
            this.done = true;
        } else if (message != null && message.getPerformative() == ACLMessage.INFORM) {
            monitor.printMessage(message.getContent());
        } else if (message != null && message.getPerformative() == ACLMessage.FAILURE) {
            try {
                   monitor.printException((Exception) message.getContentObject());
                } catch (UnreadableException e) {
                    e.printStackTrace();
                }
            monitor.stopAnimation();
            this.done = true;
        }
    }
}

