package fr.unistra.ibmc.s2s.behaviours;

import fr.unistra.ibmc.paradise.tools.AnswerBehaviour;
import fr.unistra.ibmc.paradise.tools.ParadiseToolAgent;
import fr.unistra.ibmc.paradise.core.Molecule;
import fr.unistra.ibmc.paradise.core.features.SecondaryStructure;
import fr.unistra.ibmc.paradise.core.analysis.Parameter;
import fr.unistra.ibmc.paradise.core.analysis.Parameters;
import fr.unistra.ibmc.s2s.S2S;

import java.util.ArrayList;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.lang.acl.UnreadableException;


public class SecondaryStructurePredictionRequestAnswerBehaviour extends AnswerBehaviour {

    public SecondaryStructurePredictionRequestAnswerBehaviour(ArrayList<Molecule> selectedMolecules, Parameters selectedParameters) {
        super(selectedMolecules, selectedParameters);
    }

    public void action() {
        ACLMessage message = myAgent.receive(MessageTemplate.MatchConversationId("" + this.conversationId));
        if (message != null && message.getPerformative() == ACLMessage.PROPOSE) {
            try {
                SecondaryStructure ss = ((ArrayList<Molecule>) message.getContentObject()).get(0).getSelectedFeatures(SecondaryStructure.class).get(0);
                SecondaryStructure copySS = ss.getFactory().copySecondaryStructure(selectedMolecules, ss, false);
                copySS.setName("Secondary Structure");
                ((S2S)((ParadiseToolAgent)myAgent).getParadiseTool()).loadRNASecondaryStructure(copySS);
                monitor.printMessage("End of Analysis");
            }
            catch (Exception e) {
                monitor.printException(e);
            }
            this.done = true;
        } else if (message != null && message.getPerformative() == ACLMessage.INFORM) {
            monitor.printMessage(message.getContent());
        } else if (message != null && message.getPerformative() == ACLMessage.FAILURE) {
            try {
                monitor.printException((Exception) message.getContentObject());
            } catch (UnreadableException e) {
                e.printStackTrace();
            }
            monitor.stopAnimation();
            this.done = true;

        }
    }
}

