package fr.unistra.ibmc.s2s.rnalign.features;

import fr.unistra.ibmc.s2s.rnalign.graphics.GraphicContext;


public class DeletionStep implements Step {

    private int deletionPosition;

    public DeletionStep(int insertionPosition) {
        this.deletionPosition = insertionPosition;
    }


    public void undo(Alignment a, GraphicContext gc) {
        for (int i = 0; i < a.getSymbolSequenceCount(); i++)
            a.getLetterSequenceAt(i).insertGap(this.deletionPosition);
    }

    public void redo(Alignment a, GraphicContext gc) {
        for (int i = 0; i < a.getSymbolSequenceCount(); i++)
            a.getLetterSequenceAt(i).removeGap(this.deletionPosition);
    }
}
