package fr.unistra.ibmc.s2s.rnalign.features;

import fr.unistra.ibmc.s2s.rnalign.graphics.GraphicContext;


public class InsertionStep implements Step {

    private int insertionPosition;


    public InsertionStep(int insertionPosition) {
        this.insertionPosition = insertionPosition;
    }


    public void undo(Alignment a, GraphicContext gc) {
        for (int i = 0; i < a.getSymbolSequenceCount(); i++)
            a.getLetterSequenceAt(i).removeGap(this.insertionPosition);
    }

    public void redo(Alignment a, GraphicContext gc) {
        for (int i = 0; i < a.getSymbolSequenceCount(); i++)
            a.getLetterSequenceAt(i).insertGap(this.insertionPosition);
    }
}
