package fr.unistra.ibmc.s2s.rnalign.graphics;

import java.awt.*;

/**
 * This class manages the common parameters to display a multiple alignment
 * within an AlignmentCanvas
 *
 * @author fjossinet
 */
public class GraphicContext {

    Font f = new java.awt.Font("Courier", java.awt.Font.PLAIN, 20);
    //the upperleft corner of the current view
    int viewX, viewY;
    int currentX, currentY, currentWidth;
    int horizontalAdvance, verticalAdvance, letterHeight, letterWidth;
    Color currentColor;
    int leftMarge;
    Rectangle drawingArea;
    boolean quickDraw;
    int ratio = 10;
    boolean tmp;
    int currentLabelSize;

    Font getFont() {
        return this.f;
    }

    public int getCurrentLabelSize() {
        return this.currentLabelSize;
    }

    void setFont(final Font f) {
        this.f = f;
    }

    public int getViewX() {
        return viewX;
    }

    public int getViewY() {
        return viewY;
    }

    void setViewX(final int positionInAlignment) {
        this.viewX = this.getHorizontalAdvance()*positionInAlignment;
    }

    void setViewY(final int viewY) {
        this.viewY = viewY;
    }

    public int getCurrentX() {
        return currentX;
    }

    public int getCurrentY() {
        return currentY;
    }

    void setCurrentX(final int currentX) {
        this.currentX = currentX;
    }

    void setCurrentY(final int currentY) {
        this.currentY = currentY;
    }

    int getHorizontalAdvance() {
        return horizontalAdvance;
    }

    public int getVerticalAdvance() {
        return verticalAdvance;
    }

    void setHorizontalAdvance(final int horizontalAdvance) {
        this.horizontalAdvance = horizontalAdvance;
    }

    void setVerticalAdvance(final int verticalAdvance) {
        this.verticalAdvance = verticalAdvance;
    }

    public int getLetterHeight() {
        return letterHeight;
    }

    void setLetterHeight(final int letterHeight) {
        this.letterHeight = letterHeight;
    }

    public int getLetterWidth() {
        return letterWidth;
    }

    void setLetterWidth(final int width) {
        this.letterWidth = width;
    }

    Color getCurrentColor() {
        return currentColor;
    }

    void setCurrentColor(final Color currentColor) {
        this.currentColor = currentColor;
    }

    void setLeftMarge(final int labelSize) {
        this.currentLabelSize = labelSize;
        this.leftMarge = labelSize * this.getHorizontalAdvance()+20;
    }

    void setDrawingArea(final Rectangle drawingArea) {
        this.drawingArea = drawingArea;
    }

    public int getRatio() {
        return ratio;
    }

    void setRatio(final int ratio) {
        this.ratio = ratio;
        if (this.ratio < 10)
            this.ratio = 10;
    }

    boolean isQuickDraw() {
        return quickDraw;
    }

    void setQuickDraw(final boolean quickDraw) {
        this.quickDraw = quickDraw;
    }

}
