package fr.unistra.ibmc.s2s.rnalign.utils;

import javax.swing.*;
import java.awt.*;


public class RessourcesUtils {
    public static Cursor getCursor(String file, Point p, String name) {
        Toolkit tk = Toolkit.getDefaultToolkit();
        Cursor ret;
        try {
            ret = tk.createCustomCursor(tk.createImage(RessourcesUtils.class.getResource("/fr/unistra/ibmc/s2s/pictures/" + file)), p, name);
        }
        catch (Exception e) {
            ret = tk.createCustomCursor(tk.createImage(RessourcesUtils.class.getResource("/fr/unistra/ibmc/s2s/pictures/filenotfound.png")), p, name);
            return ret;
        }
        return ret;
    }


    public static Icon getIcon(String file) {
        Icon ret;
        try {
            ret = new ImageIcon(getImage(file));
        }
        catch (Exception e) {
            ret = new ImageIcon(getImage("filenotfound.png"));
            return ret;
        }
        return ret;
    }


    public static Image getImage(final String imageName) {

        if (imageName == null) {
            return null;
        }
        Image image = null;
        final Toolkit toolkit = Toolkit.getDefaultToolkit();
        try {
            image = toolkit.getImage(RessourcesUtils.class.getResource("/fr/unistra/ibmc/s2s/pictures/" +imageName));
        }
        catch (Exception exc) {
            image = toolkit.createImage(RessourcesUtils.class.getResource("/fr/unistra/ibmc/s2s/pictures/filenotfound.png"));
        }
        return image;
    }
}
