/*
 * GCWC.java
 *
 * Created on 17 janvier 2003, 15:23
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;

import java.awt.geom.Point2D;

/**
 * @author fabricej
 */
public class GCWC extends BaseBaseInteraction2D {

    GCWC(final BaseBaseInteraction i, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(i, repository, mediator,gc);
    }

    protected void setRealSymbol(final Point2D point1, final Point2D point2, final double distance) {
        final Residue2D base = this.repository.getResidue(this.interaction.getResidue());
        final Residue2D partnerBase = this.repository.getResidue(this.interaction.getPartnerResidue());
        final Point2D[] points1 = DrawingUtils.getPerpendicular(point1, base.getRealCoordinates(), partnerBase.getRealCoordinates(), distance / 16);
        final Point2D[] points2 = DrawingUtils.getPerpendicular(point2, base.getRealCoordinates(), partnerBase.getRealCoordinates(), distance / 16);
        this.realSymbol.addSymbol(new Line(points1[0], points2[0], this.gc));
        this.realSymbol.addSymbol(new Line(points1[1], points2[1], this.gc));
    }

}
