package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;

/**
 * @author fabricej
 */
class Line extends Symbol {

    Line(final java.awt.geom.Point2D p1, final java.awt.geom.Point2D p2, GraphicContext gc) {
        super(gc);
        this.shape = new java.awt.geom.Line2D.Double(p1, p2);
    }

    public void drawShape(final java.awt.Graphics2D g2) {
        g2.draw(this.shape);
    }

    public String toSVG() {
        final StringBuffer svg = new StringBuffer();
        svg.append("<line style=\" fill :none ; stroke : " + DrawingUtils.colorToString(this.getSVGColor()) + "; \" x1=\"" + (((java.awt.geom.Line2D.Double) this.shape).x1 - gc.getViewX()) / gc.getFinalZoomLevel() + "\" y1=\"" + (((java.awt.geom.Line2D.Double) this.shape).y1 - gc.getViewY()) / gc.getFinalZoomLevel() +
                "\" x2=\"" + (((java.awt.geom.Line2D.Double) this.shape).x2 - gc.getViewX()) / gc.getFinalZoomLevel() + "\" y2=\"" + (((java.awt.geom.Line2D.Double) this.shape).y2 - gc.getViewY()) / gc.getFinalZoomLevel() + "\"/>\n");
        return svg.toString();
    }

    public String toString() {
        return "Line";
    }

}
