/*
 * PhosphodiesterBond2D.java
 *
 * Created on 28 janvier 2003, 17:39
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.paradise.core.utils.Residue;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;
import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;

import java.awt.geom.Point2D;

/**
 * @author fjossinet
 */
public class PhosphodiesterBond2D extends Interaction2D {

    PhosphodiesterBond2D(Residue residue5,Residue  residue3, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(repository, residue5, residue3,mediator, gc);
        if (this.getResidue() != null)
            this.getResidue().setPhosphodiesterBond2D(this);
    }

    protected void setDefaultSymbol() {
        this.defaultSymbol.clear();
        if (op != null) {
            //we determine the distance between the two new points
            final double distance = DrawingUtils.getDistance(op[0], op[1]);
            this.defaultSymbol.addSymbol(new Line(op[0], op[1], this.gc));
            if (distance >= this.gc.getCurrentSymbolSize() / 3 && this.gc.isFiveToThreeOrientationDisplayed()) {
                final Point2D[] points = DrawingUtils.fit(op[0].getX(), op[0].getY(), op[1].getX(), op[1].getY(), (distance-gc.getCurrentSymbolSize()/2)/2);
                this.defaultSymbol.addSymbol(new Triangle(points[0], points[1], this.getResidue(), this.getPartnerResidue(), gc.getCurrentSymbolSize(), BaseBaseInteraction.ORIENTATION_CIS, this.gc));
            }
        }
    }

    protected void setRealSymbol() {
        this.setDefaultSymbol();
    }

    protected SymbolsArray getRealSymbol() {
        return this.getDefaultSymbol();
    }

        public String toSVG() {
        this.setOutsidePoints();
        if (this.real_op != null) {
            //calculate the outside points fitted with the current view and zoom level
            this.op = new java.awt.geom.Point2D[2];
            this.op[0] = new java.awt.geom.Point2D.Double(this.real_op[0]
                    .getX()
                    * this.gc.getFinalZoomLevel() + this.gc.getViewX(),
                    this.real_op[0].getY() * this.gc.getFinalZoomLevel()
                            + this.gc.getViewY());
            this.op[1] = new java.awt.geom.Point2D.Double(this.real_op[1]
                    .getX()
                    * this.gc.getFinalZoomLevel() + this.gc.getViewX(),
                    this.real_op[1].getY() * this.gc.getFinalZoomLevel()
                            + this.gc.getViewY());
        }
        //we remove the precedent op points if no real_op
        else
            this.op = null;
        this.setDefaultSymbol();
        return this.toSVGDefault();
    }


    protected void setRealSymbol(Point2D point1, Point2D point2, double distance) {

    }
}
