/*
 * TransSESE.java
 *
 * Created on 17 janvier 2003, 15:35
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;

import java.awt.geom.Point2D;

/**
 * @author fabricej
 */
public class SESE extends BaseBaseInteraction2D {

    private char edge5, edge3;

    SESE(final BaseBaseInteraction i, final Residues2DRepository repository, final char edge5, final char edge3, final Mediator mediator, final GraphicContext gc) {
        super(i, repository, mediator,gc);
        this.edge5 = edge5;
        this.edge3 = edge3;
    }

    protected void setRealSymbol(final Point2D point1, final Point2D point2, final double distance) {
        //we divide the symbol in three part each enclosing 1/3 of the distance
        final Point2D[] points = DrawingUtils.fit(point1.getX(), point1.getY(), point2.getX(), point2.getY(), distance / 3);
        //we draw the lines
        this.realSymbol.addSymbol(new Line(point1, points[0], this.gc));
        this.realSymbol.addSymbol(new Line(point2, points[1], this.gc));
        //we draw the triangle
        if (this.edge5 == 'S')
            this.realSymbol.addSymbol(new Triangle(points[0], points[1], this.repository.getResidue(this.interaction.getResidue()), this.repository.getResidue(this.interaction.getPartnerResidue()), distance, this.interaction.getOrientation(), this.gc));
        else
            this.realSymbol.addSymbol(new Triangle(points[1], points[0], this.repository.getResidue(this.interaction.getResidue()), this.repository.getResidue(this.interaction.getPartnerResidue()), distance, this.interaction.getOrientation(), this.gc));
    }

}
