package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;

import java.util.ArrayList;
import java.util.List;

public class Sequence2D {

    private List<Residue2D> residues;

    Sequence2D (int sequenceLength) {
        this.residues = new ArrayList<Residue2D>(sequenceLength);
    }

    public Residue2D getResidue(final int absolutePosition) {
        if (absolutePosition - 1 >= this.residues.size() || absolutePosition - 1 < 0)
            return null;
        return this.residues.get(absolutePosition - 1);
    }

    public String getSequence() {
        final StringBuffer buffer = new StringBuffer(this.residues.size());
        for (int j = 0; j < this.residues.size(); j++)
            buffer.append((this.residues.get(j)).getSymbol());
        return buffer.toString();
    }

    public void addResidue2D(fr.unistra.ibmc.paradise.core.features.Residue2D r, Residues2DRepository repository, final Mediator mediator,final GraphicContext gc) {
        this.residues.add(r.getResidues().iterator().next().getAbsolutePosition()-1,new Residue2D(r,repository, mediator, gc));
    }
}
