/*
 * SingleHBond.java
 *
 * Created on 17 janvier 2003, 15:42
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.utils.Residue;

import java.awt.geom.Point2D;

/**
 * @author fabricej
 */
public class SingleHBond extends Interaction2D {

    SingleHBond(final Residue r1, final Residue r2, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(repository,r1, r2, mediator, gc);
    }

    protected void setRealSymbol() {
        this.realSymbol.clear();
        if (op != null) {
            this.setRealSymbol(op[0], op[1], 5.0/*5px for each dot line*/);
        }
    }

    protected void setRealSymbol(final Point2D point1, final Point2D point2, final double distance) {
        if (DrawingUtils.getDistance(point1, point2) > distance) {
            final Point2D[] points = DrawingUtils.fit(point1.getX(), point1.getY(), point2.getX(), point2.getY(), distance);
            this.realSymbol.addSymbol(new Line(point1, points[0], this.gc));
            if (DrawingUtils.getDistance(points[0], point2) > distance) {
                final Point2D[] npoints = DrawingUtils.fit(points[0].getX(), points[0].getY(), point2.getX(), point2.getY(), distance);
                this.setRealSymbol(npoints[0], point2, distance);
            }
        } else
            this.realSymbol.addSymbol(new Line(point1, point2, this.gc));
    }

    public Byte getFamily() {
        return (byte)16;
    }
}
