package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;

/**
 * @author fabricej
 */
class Squarre extends Symbol {

    private java.awt.geom.Point2D[] startPoints, endPoints;

    /**
     * Creates a new instance of Squarre
     */
    Squarre(final java.awt.geom.Point2D startPoint, final java.awt.geom.Point2D endPoint, final Residue2D base5, final Residue2D base3, final double distance, final char orientation, GraphicContext gc) {
        super(orientation, gc);
        this.shape = new java.awt.geom.GeneralPath();
        this.startPoints = DrawingUtils.getPerpendicular(startPoint, base5.getRealCoordinates(), base3.getRealCoordinates(), distance / 6);
        this.endPoints = DrawingUtils.getPerpendicular(endPoint, base5.getRealCoordinates(), base3.getRealCoordinates(), distance / 6);
        ((java.awt.geom.GeneralPath) this.shape).moveTo((float) startPoints[0].getX(), (float) startPoints[0].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) endPoints[0].getX(), (float) endPoints[0].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) endPoints[1].getX(), (float) endPoints[1].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) startPoints[1].getX(), (float) startPoints[1].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) startPoints[0].getX(), (float) startPoints[0].getY());
        ((java.awt.geom.GeneralPath) this.shape).closePath();
    }


    public String toSVG() {
        final StringBuffer svg = new StringBuffer();
        svg.append("<polygon " + super.getSVGStyle(this.getSVGColor()) + " points=\"" +
                (endPoints[0].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (endPoints[0].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + " " +
                (endPoints[1].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (endPoints[1].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + " " +
                (startPoints[1].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (startPoints[1].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + " " +
                (startPoints[0].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (startPoints[0].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + "\"/>\n");
        return svg.toString();
    }

    public String toString() {
        return "Squarre";
    }

}
