package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.paradise.core.features.StructuralDomain;
import fr.unistra.ibmc.paradise.core.utils.Residue;

import java.awt.geom.Point2D;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

public abstract class StructuralDomain2D extends Rna2DElement {

    protected StructuralDomain structuralDomain;

    StructuralDomain2D(final StructuralDomain structuralDomain, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(repository, mediator, gc);
        this.structuralDomain = structuralDomain;
    }

    public StructuralDomain getStructuralDomain() {
        return structuralDomain;
    }

    public Residue2D getResidue(int absolutePosition) {
        return this.repository.getResidue(this.structuralDomain.getMolecules().iterator().next().getParadiseID(),absolutePosition);
    }

    abstract public void setCoordinates();

    abstract public void flipEnds(Point2D center);

    abstract public void rotateEnds(java.awt.geom.Point2D centerPoint, double angle);

    abstract public void translateEnds(double dragX, double dragY);

    public int getLength() {
        return this.structuralDomain.getLength();
    }

    public List<Residue2D> getResidues() {
        List<Residue2D> residues = new ArrayList<Residue2D>();
        Iterator i = this.structuralDomain.getResidues().iterator();
        while (i.hasNext())
            residues.add(this.repository.getResidue((Residue)i.next()));
        return residues;
    }

    public boolean contains(Residue r) {
        return this.structuralDomain.contains(r);
    }
}
