package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;

/**
 * @author fabricej
 */
class Triangle extends Symbol {

    private java.awt.geom.Point2D[] startPoints;
    private java.awt.geom.Point2D endPoint;

    /**
     * Creates a new instance of Triangle
     */
    Triangle(final java.awt.geom.Point2D startPoint, final java.awt.geom.Point2D endPoint, final Residue2D base5, final Residue2D base3, final double distance, final char orientation, GraphicContext gc) {
        super(orientation, gc);
        this.shape = new java.awt.geom.GeneralPath();
        this.endPoint = endPoint;
        this.startPoints = DrawingUtils.getPerpendicular(startPoint, base5.getRealCoordinates(), base3.getRealCoordinates(), distance / 6);
        ((java.awt.geom.GeneralPath) this.shape).moveTo((float) startPoints[0].getX(), (float) startPoints[0].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) startPoints[1].getX(), (float) startPoints[1].getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) endPoint.getX(), (float) endPoint.getY());
        ((java.awt.geom.GeneralPath) this.shape).lineTo((float) startPoints[0].getX(), (float) startPoints[0].getY());
        ((java.awt.geom.GeneralPath) this.shape).closePath();
    }


    public String toSVG() {
        final StringBuffer svg = new StringBuffer();
        svg.append("<polygon " + super.getSVGStyle(this.getSVGColor()) + " points=\"" +
                (startPoints[1].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (startPoints[1].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + " " +
                (endPoint.getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (endPoint.getY() - gc.getViewY()) / gc.getFinalZoomLevel() + " " +
                (startPoints[0].getX() - gc.getViewX()) / gc.getFinalZoomLevel() + "," +
                (startPoints[0].getY() - gc.getViewY()) / gc.getFinalZoomLevel() + "\"/>\n");
        return svg.toString();
    }

    public String toString() {
        return "Triangle";
    }

}
