/*
 * Unknown.java
 * This class draws an unknow interaction
 * In all the cases (default and real symbols) the symbol is an interrogation point)
 *
 * Created on 22 janvier 2003, 10:53
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;

import java.awt.geom.Point2D;

/**
 * If an interaction has been described in an rnaml file with no correspondances for Rna2DViewer,
 * it will be drawn as an unkown interaction (with a cross symbol, not used in the Leontis and Westhof
 * classification)
 *
 * @author fabricej
 */
public class Unknown extends BaseBaseInteraction2D {

    Unknown(final BaseBaseInteraction i, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(i, repository, mediator,gc);
    }

    protected void setRealSymbol(final java.awt.geom.Point2D point1, final java.awt.geom.Point2D point2, final double distance) {
        final Residue2D base = this.repository.getResidue(this.interaction.getResidue());
        final Residue2D partnerBase = this.repository.getResidue(this.interaction.getPartnerResidue());
        final Point2D[] points1 = DrawingUtils.getPerpendicular(point1, base.getRealCoordinates(), partnerBase.getRealCoordinates(), distance / 16);
        final Point2D[] points2 = DrawingUtils.getPerpendicular(point2, base.getRealCoordinates(), partnerBase.getRealCoordinates(), distance / 16);
        this.realSymbol.addSymbol(new Line(points1[0], points2[1], this.gc));
        this.realSymbol.addSymbol(new Line(points1[1], points2[0], this.gc));
    }

}
