/*
 * TransWCSE.java
 *
 * Created on 17 janvier 2003, 15:38
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;

import java.awt.geom.Point2D;

/**
 * @author fabricej
 */
public class WCSE extends BaseBaseInteraction2D {

    WCSE(final BaseBaseInteraction i, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(i, repository, mediator,gc);
    }

    protected void setRealSymbol(final Point2D point1, final Point2D point2, final double distance) {
        //we divide the symbol in three part each enclosing 1/3 of the distance
        final Point2D[] points = DrawingUtils.fit(point1.getX(), point1.getY(), point2.getX(), point2.getY(), distance / 3);
        //we draw the circle
        //the center of the circle (two curve joined)
        final Point2D center = DrawingUtils.fit(point1.getX(), point1.getY(), point2.getX(), point2.getY(), distance / 6)[0];
        this.realSymbol.addSymbol(new Circle(points[0], center, this.interaction.getOrientation(), this.gc));
        //we construct the triangle
        this.realSymbol.addSymbol(new Triangle(points[1], point2, this.repository.getResidue(this.interaction.getResidue()), this.repository.getResidue(this.interaction.getPartnerResidue()), distance, this.interaction.getOrientation(), this.gc));
        //we draw the line between the two forms
        this.realSymbol.addSymbol(new Line(points[0], points[1], this.gc));
    }

}
