/*
 * TransWCWC.java
 *
 * Created on 17 janvier 2003, 15:32
 */

package fr.unistra.ibmc.s2s.ssviewer.features;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.graphics.GraphicContext;
import fr.unistra.ibmc.s2s.ssviewer.utils.DrawingUtils;
import fr.unistra.ibmc.paradise.core.features.BaseBaseInteraction;

import java.awt.geom.Point2D;

/**
 * @author fabricej
 */
public class WCWC extends BaseBaseInteraction2D {

    WCWC(final BaseBaseInteraction i, final Residues2DRepository repository, final Mediator mediator, final GraphicContext gc) {
        super(i, repository, mediator,gc);
    }

    protected void setRealSymbol(final Point2D point1, final Point2D point2, final double distance) {
        //we divide the symbol in three part each enclosing 1/3 of the distance
        final Point2D[] points = DrawingUtils.fit(point1.getX(), point1.getY(), point2.getX(), point2.getY(), distance / 3);
        //we draw the lines
        this.realSymbol.addSymbol(new Line(point1, points[0], this.gc));
        this.realSymbol.addSymbol(new Line(point2, points[1], this.gc));
        //we draw the circle
        //the center of the circle
        final Point2D center = new Point2D.Double((point1.getX() + point2.getX()) / 2, (point1.getY() + point2.getY()) / 2);
        this.realSymbol.addSymbol(new Circle(points[0], center, this.interaction.getOrientation(), this.gc));
    }
}

        
        
    
