package fr.unistra.ibmc.s2s.ssviewer.graphics;

import fr.unistra.ibmc.s2s.Mediator;


/**
 * @author fjossinet
 */
class ClearZoomState extends ZoomState {

    ClearZoomState(Mediator mediator) {
        super(mediator);
    }

    void mouseClicked(final java.awt.event.MouseEvent e) {
        //we calculate the coordinates of the point clicked as real coordinates inside the 2D structure
        this.zoomView(1 / this.mediator.getSecondaryCanvas().getGraphicContext().getFinalZoomLevel(), new java.awt.geom.Point2D.Double((e.getPoint().getX() - this.mediator.getSecondaryCanvas().getViewX()) / this.mediator.getSecondaryCanvas().getFinalZoomLevel(), (e.getPoint().getY() - this.mediator.getSecondaryCanvas().getViewY()) / this.mediator.getSecondaryCanvas().getFinalZoomLevel()));
    }

    void zoomView(final double zoomLevel, final java.awt.geom.Point2D zoomCenter) {
        super.zoomView(zoomLevel, zoomCenter);
        this.mediator.getSecondaryCanvas().zoomView(zoomLevel);
        //we calculate the coordinates within the canvas (after zoom) of the point clicked
        java.awt.geom.Point2D newDisplayZoomCenter = new java.awt.geom.Point2D.Double(zoomCenter.getX() * this.mediator.getSecondaryCanvas().getFinalZoomLevel() + this.mediator.getSecondaryCanvas().getViewX(), zoomCenter.getY() * this.mediator.getSecondaryCanvas().getFinalZoomLevel() + this.mediator.getSecondaryCanvas().getViewY());
        //we center the view on this point
        this.mediator.getSecondaryCanvas().translateView(this.mediator.getSecondaryCanvas().getWidth() / 2 - newDisplayZoomCenter.getX(), this.mediator.getSecondaryCanvas().getHeight() / 2 - newDisplayZoomCenter.getY());
    }

}
