package fr.unistra.ibmc.s2s.ssviewer.graphics;

import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.s2s.ssviewer.features.Residue2D;

import java.awt.geom.Point2D;
import java.util.List;

/**
 * @author fabricej
 */
class RotationState extends State {

    private java.awt.geom.Point2D pickingCenter;
    private Point2D centerofRotation;

    RotationState(Mediator mediator) {
        super(mediator);
    }

    void mouseDragged(final java.awt.event.MouseEvent e) {
        this.mediator.getSecondaryCanvas().rotateSelection(e.isShiftDown() ? 5.0 : (e.getX() - this.pickingCenter.getX() + e.getY() - this.pickingCenter.getY()) / 10, this.centerofRotation);
    }

    void mousePressed(final java.awt.event.MouseEvent e) {
        this.pickingCenter = new java.awt.geom.Point2D.Double(e.getPoint().getX(), e.getPoint().getY());
        double centerX = 0, centerY = 0;
        List<Residue2D> residues = this.mediator.getSecondaryCanvas().getCurrentResidues();
        for (Residue2D r:residues) {
            centerX+=r.getCurrentCenterX();
            centerY+=r.getCurrentCenterY();
        }
        centerX = centerX /residues.size();
        centerY = centerY /residues.size();
        this.centerofRotation = new Point2D.Double(centerX,centerY);
    }

}
