package fr.unistra.ibmc.s2s.ssviewer.graphics;

import java.awt.geom.Point2D;
import fr.unistra.ibmc.s2s.ssviewer.features.Rna2DElement;
import fr.unistra.ibmc.s2s.Mediator;
import fr.unistra.ibmc.paradise.core.utils.Residue;


/**
 * During the paint process, the SelectState classes are searching
 * the element selected by the user to register it for the next manipulations
 *
 * @author fabricej
 */
abstract class SelectState extends State {

    Point2D corner;

    SelectState(Mediator mediator) {
        super(mediator);
    }

    void mouseClicked(final java.awt.event.MouseEvent e) {
    }

    void mouseDragged(final java.awt.event.MouseEvent e) {

    }

    void mousePressed(final java.awt.event.MouseEvent e) {
        if (e.isShiftDown())
            this.corner = new Point2D.Double(e.getX(), e.getY());
    }

    void mouseReleased(final java.awt.event.MouseEvent e) {
        if (this.mediator.getSecondaryCanvas().selectionRectangle != null) {
            this.mediator.getSecondaryCanvas().selectionRectangle = null;
            this.mediator.getSecondaryCanvas().repaint();
        }
    }

    void mouseMoved(final java.awt.event.MouseEvent e) {
    }

    /**
     * @param residue the Rna2DNode wrapping the residue selected
     * @return
     */
    abstract Rna2DElement getWrapper(Residue residue);

}
