package fr.unistra.ibmc.s2s.ssviewer.graphics;

import fr.unistra.ibmc.s2s.ssviewer.features.Residue2D;
import fr.unistra.ibmc.s2s.Mediator;

import java.util.List;


/**
 * A state will define the behavoir against the events catches by the SecondaryCanvas2D.
 * It paints the Model2D (the secondaryCanvas send the message to it). This is useful
 * specialy for the SelectState objects where the process to research the element
 * selected can be done during the paint process.
 *
 * @author fabricej
 */
abstract public class State {

    protected Mediator mediator;

    protected State(Mediator mediator) {
        this.mediator = mediator;
    }

    void mouseClicked(final java.awt.event.MouseEvent e) {
    }

    void mouseDragged(final java.awt.event.MouseEvent e) {
    }

    void mouseMoved(final java.awt.event.MouseEvent e) {
    }

    void mousePressed(final java.awt.event.MouseEvent e) {
    }

    void mouseReleased(final java.awt.event.MouseEvent e) {
    }

    /**
     * Select the RNA object containing the residues given as argument
     * @param residues
     */
    public void select(SecondaryCanvas canvas, List<Residue2D> residues) {

    }


}
