package fr.unistra.ibmc.s2s.tertiaryviewers;

import org.jdesktop.swingworker.SwingWorker;

import java.io.*;

/**
 * A driver for an application staying alive until an explicit close message.
 * This Driver is designed to launch and communicate with a graphical application for example
 */
public abstract class OnHangApplicationDriver extends AbstractDriver {

    protected Process process;

    protected OnHangApplicationDriver(final String program) {
        super(program);
    }

    public void run(final String[] options, File inputFile, File outputFile) {
        String[] command = new String[options.length + 1 /*1 is for the command name*/];
        command[0] = program;
        int i = 0;
        for (; i < options.length; i++)
            command[i + 1] = options[i];
        try {
            StringBuffer b = new StringBuffer(command[0]);
            for (int k = 1; k < command.length; k++) {
                b.append(" ");
                b.append(command[k]);
            }
            //System.out.println("Launch command : " + b.toString());
            this.process = Runtime.getRuntime().exec(b.toString() + " " + ((inputFile != null) ? inputFile.getAbsolutePath() : ""));
        }
        catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }

    public void evaluate(final String command) {
        new SwingWorker() {
            private PrintWriter commandInput;

            protected Object doInBackground() throws Exception {
                this.commandInput = new PrintWriter((new OutputStreamWriter(new BufferedOutputStream(process.getOutputStream()))), true);
                this.commandInput.println(command);
                return null;        }

        }.execute();

        new SwingWorker() {
            private BufferedReader commandOutput;

            public Object doInBackground() throws Exception {
                this.commandOutput = new BufferedReader(new InputStreamReader(process.getInputStream()));
                try {
                    this.commandOutput.readLine();
                }
                catch (IOException e) {
                    System.out.println(e.getMessage());
                    return null;
                }
                return null;
            }
        }.execute();

        new SwingWorker() {
            private BufferedReader errorStream;

            public Object doInBackground() throws Exception {
                this.errorStream = new BufferedReader(new InputStreamReader(process.getErrorStream()));
                try {
                    this.errorStream.readLine();
                }
                catch (IOException e) {
                    System.out.println(e.getMessage());
                    return null;
                }
                return null;
            }
        }.execute();
    }
}
