package fr.unistra.ibmc.s2s.tertiaryviewers;

import fr.unistra.ibmc.paradise.core.utils.Residue;
import fr.unistra.ibmc.paradise.core.features.TertiaryStructure;
import fr.unistra.ibmc.s2s.tertiaryviewers.Driver;
import fr.unistra.ibmc.s2s.SelectionListener;

import java.io.File;
import java.util.List;
import java.util.Collection;


public interface TertiaryViewerDriver extends Driver, SelectionListener {

    public static final int SELECT = 0, CENTER = 1, ZOOM = 2, SHOW = 3,HIDE = 4 ;

    public void loadTertiaryStructure(File f);

    public void select(final Collection<Residue> residues);

    public void showSelection(final Collection<Residue> residues);

    public void hideSelection(final Collection<Residue> residues);

    public void zoomSelection(final Collection<Residue> residues);

    public void centerSelection(final Collection<Residue> residues);

    public void clearDisplay();

    public List<TertiaryStructure> getTertiaryStructuresDisplayed();

    public void addTertiaryStructureDisplayed(TertiaryStructure ts);

    public void addSelectionListener(SelectionListener l);

    public void setCurrentState(int state);
}
